/* This file is automatically generated by Lemon from input grammar
** source file "../../groonga/lib/grn_ecmascript.lemon". */
/*
** 2000-05-29
**
** The author disclaims copyright to this source code.  In place of
** a legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
**
*************************************************************************
** Driver template for the LEMON parser generator.
**
** The "lemon" program processes an LALR(1) input grammar file, then uses
** this template to construct a parser.  The "lemon" program inserts text
** at each "%%" line.  Also, any "P-a-r-s-e" identifer prefix (without the
** interstitial "-" characters) contained in this template is changed into
** the value of the %name directive from the grammar.  Otherwise, the content
** of this template is copied straight through into the generate parser
** source file.
**
** The following is the concatenation of all %include directives from the
** input grammar file:
*/
/************ Begin %include sections from the grammar ************************/
#line 4 "../../groonga/lib/grn_ecmascript.lemon"

#ifdef assert
#  undef assert
#endif
#define assert GRN_ASSERT

  static void
  array_literal_add_element(efs_info *efsi)
  {
    grn_ctx *ctx = efsi->ctx;
    grn_expr *e = (grn_expr *)(efsi->e);
    grn_expr_code *code = &(e->codes[e->codes_curr - 1]);
    if (code->op != GRN_OP_PUSH) {
      if (!efsi->array_literal) {
        efsi->array_literal = grn_obj_open(ctx, GRN_VECTOR, 0, GRN_ID_NIL);
      }
      ERR(GRN_FUNCTION_NOT_IMPLEMENTED,
          "complex expression in array literal isn't supported yet: <%.*s>",
          (int)(efsi->str_end - efsi->str), efsi->str);
    }
    if (ctx->rc == GRN_SUCCESS) {
      grn_obj *element = code->value;
      if (!efsi->array_literal) {
        efsi->array_literal = grn_obj_open(ctx,
                                           GRN_VECTOR,
                                           0,
                                           element->header.domain);
        if (!efsi->array_literal) {
          ERR(GRN_NO_MEMORY_AVAILABLE,
              "couldn't create vector for parsing array literal: <%.*s>",
              (int)(efsi->str_end - efsi->str), efsi->str);
        }
      }
      if (efsi->array_literal) {
        grn_vector_add_element_float(ctx,
                                     efsi->array_literal,
                                     GRN_TEXT_VALUE(element),
                                     GRN_TEXT_LEN(element),
                                     0,
                                     element->header.domain);
        if (ctx->rc == GRN_SUCCESS) {
          grn_expr_dfi_pop(e);
          e->codes_curr -= 1;
        }
      }
    }
  }
#line 77 "../../groonga/lib/grn_ecmascript.c"
/**************** End of %include directives **********************************/
/* These constants specify the various numeric values for terminal symbols.
***************** Begin token definitions *************************************/
#ifndef GRN_EXPR_TOKEN_START_OUTPUT_COLUMNS
#define GRN_EXPR_TOKEN_START_OUTPUT_COLUMNS            1
#define GRN_EXPR_TOKEN_START_ADJUSTER                  2
#define GRN_EXPR_TOKEN_START_SORT_KEYS                 3
#define GRN_EXPR_TOKEN_LOGICAL_AND                     4
#define GRN_EXPR_TOKEN_LOGICAL_AND_NOT                 5
#define GRN_EXPR_TOKEN_LOGICAL_OR                      6
#define GRN_EXPR_TOKEN_NEGATIVE                        7
#define GRN_EXPR_TOKEN_QSTRING                         8
#define GRN_EXPR_TOKEN_PARENL                          9
#define GRN_EXPR_TOKEN_PARENR                         10
#define GRN_EXPR_TOKEN_ADJUST                         11
#define GRN_EXPR_TOKEN_RELATIVE_OP                    12
#define GRN_EXPR_TOKEN_IDENTIFIER                     13
#define GRN_EXPR_TOKEN_BRACEL                         14
#define GRN_EXPR_TOKEN_BRACER                         15
#define GRN_EXPR_TOKEN_EVAL                           16
#define GRN_EXPR_TOKEN_COMMA                          17
#define GRN_EXPR_TOKEN_ASSIGN                         18
#define GRN_EXPR_TOKEN_STAR_ASSIGN                    19
#define GRN_EXPR_TOKEN_SLASH_ASSIGN                   20
#define GRN_EXPR_TOKEN_MOD_ASSIGN                     21
#define GRN_EXPR_TOKEN_PLUS_ASSIGN                    22
#define GRN_EXPR_TOKEN_MINUS_ASSIGN                   23
#define GRN_EXPR_TOKEN_SHIFTL_ASSIGN                  24
#define GRN_EXPR_TOKEN_SHIFTR_ASSIGN                  25
#define GRN_EXPR_TOKEN_SHIFTRR_ASSIGN                 26
#define GRN_EXPR_TOKEN_AND_ASSIGN                     27
#define GRN_EXPR_TOKEN_XOR_ASSIGN                     28
#define GRN_EXPR_TOKEN_OR_ASSIGN                      29
#define GRN_EXPR_TOKEN_QUESTION                       30
#define GRN_EXPR_TOKEN_COLON                          31
#define GRN_EXPR_TOKEN_BITWISE_OR                     32
#define GRN_EXPR_TOKEN_BITWISE_XOR                    33
#define GRN_EXPR_TOKEN_BITWISE_AND                    34
#define GRN_EXPR_TOKEN_EQUAL                          35
#define GRN_EXPR_TOKEN_NOT_EQUAL                      36
#define GRN_EXPR_TOKEN_LESS                           37
#define GRN_EXPR_TOKEN_GREATER                        38
#define GRN_EXPR_TOKEN_LESS_EQUAL                     39
#define GRN_EXPR_TOKEN_GREATER_EQUAL                  40
#define GRN_EXPR_TOKEN_IN                             41
#define GRN_EXPR_TOKEN_MATCH                          42
#define GRN_EXPR_TOKEN_NEAR                           43
#define GRN_EXPR_TOKEN_NEAR2                          44
#define GRN_EXPR_TOKEN_NEAR_PHRASE                    45
#define GRN_EXPR_TOKEN_ORDERED_NEAR_PHRASE            46
#define GRN_EXPR_TOKEN_SIMILAR                        47
#define GRN_EXPR_TOKEN_TERM_EXTRACT                   48
#define GRN_EXPR_TOKEN_QUORUM                         49
#define GRN_EXPR_TOKEN_LCP                            50
#define GRN_EXPR_TOKEN_PREFIX                         51
#define GRN_EXPR_TOKEN_SUFFIX                         52
#define GRN_EXPR_TOKEN_REGEXP                         53
#define GRN_EXPR_TOKEN_SHIFTL                         54
#define GRN_EXPR_TOKEN_SHIFTR                         55
#define GRN_EXPR_TOKEN_SHIFTRR                        56
#define GRN_EXPR_TOKEN_PLUS                           57
#define GRN_EXPR_TOKEN_MINUS                          58
#define GRN_EXPR_TOKEN_STAR                           59
#define GRN_EXPR_TOKEN_SLASH                          60
#define GRN_EXPR_TOKEN_MOD                            61
#define GRN_EXPR_TOKEN_DELETE                         62
#define GRN_EXPR_TOKEN_INCR                           63
#define GRN_EXPR_TOKEN_DECR                           64
#define GRN_EXPR_TOKEN_NOT                            65
#define GRN_EXPR_TOKEN_BITWISE_NOT                    66
#define GRN_EXPR_TOKEN_EXACT                          67
#define GRN_EXPR_TOKEN_PARTIAL                        68
#define GRN_EXPR_TOKEN_UNSPLIT                        69
#define GRN_EXPR_TOKEN_DECIMAL                        70
#define GRN_EXPR_TOKEN_HEX_INTEGER                    71
#define GRN_EXPR_TOKEN_STRING                         72
#define GRN_EXPR_TOKEN_BOOLEAN                        73
#define GRN_EXPR_TOKEN_NULL                           74
#define GRN_EXPR_TOKEN_BRACKETL                       75
#define GRN_EXPR_TOKEN_BRACKETR                       76
#define GRN_EXPR_TOKEN_DOT                            77
#define GRN_EXPR_TOKEN_NONEXISTENT_COLUMN             78
#endif
/**************** End token definitions ***************************************/

/* The next sections is a series of control #defines.
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used to store the integer codes
**                       that represent terminal and non-terminal symbols.
**                       "unsigned char" is used if there are fewer than
**                       256 symbols.  Larger types otherwise.
**    YYNOCODE           is a number of type YYCODETYPE that is not used for
**                       any terminal or nonterminal symbol.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       (also known as: "terminal symbols") have fall-back
**                       values which should be used if the original symbol
**                       would not parse.  This permits keywords to sometimes
**                       be used as identifiers, for example.
**    YYACTIONTYPE       is the data type used for "action codes" - numbers
**                       that indicate what to do in response to the next
**                       token.
**    grn_expr_parserTOKENTYPE     is the data type used for minor type for terminal
**                       symbols.  Background: A "minor type" is a semantic
**                       value associated with a terminal or non-terminal
**                       symbols.  For example, for an "ID" terminal symbol,
**                       the minor type might be the name of the identifier.
**                       Each non-terminal can have a different minor type.
**                       Terminal symbols all have the same minor type, though.
**                       This macros defines the minor type for terminal 
**                       symbols.
**    YYMINORTYPE        is the data type used for all minor types.
**                       This is typically a union of many types, one of
**                       which is grn_expr_parserTOKENTYPE.  The entry in the union
**                       for terminal symbols is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.  If
**                       zero the stack is dynamically sized using realloc()
**    grn_expr_parserARG_SDECL     A static variable declaration for the %extra_argument
**    grn_expr_parserARG_PDECL     A parameter declaration for the %extra_argument
**    grn_expr_parserARG_PARAM     Code to pass %extra_argument as a subroutine parameter
**    grn_expr_parserARG_STORE     Code to store %extra_argument into yypParser
**    grn_expr_parserARG_FETCH     Code to extract %extra_argument from yypParser
**    grn_expr_parserCTX_*         As grn_expr_parserARG_ except for %extra_context
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYNTOKEN           Number of terminal symbols
**    YY_MAX_SHIFT       Maximum value for shift actions
**    YY_MIN_SHIFTREDUCE Minimum value for shift-reduce actions
**    YY_MAX_SHIFTREDUCE Maximum value for shift-reduce actions
**    YY_ERROR_ACTION    The yy_action[] code for syntax error
**    YY_ACCEPT_ACTION   The yy_action[] code for accept
**    YY_NO_ACTION       The yy_action[] code for no-op
**    YY_MIN_REDUCE      Minimum value for reduce actions
**    YY_MAX_REDUCE      Maximum value for reduce actions
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/************* Begin control #defines *****************************************/
#define YYCODETYPE unsigned char
#define YYNOCODE 118
#define YYACTIONTYPE unsigned short int
#define grn_expr_parserTOKENTYPE  int 
typedef union {
  int yyinit;
  grn_expr_parserTOKENTYPE yy0;
  void * yy229;
} YYMINORTYPE;
#ifndef YYSTACKDEPTH
#define YYSTACKDEPTH 100
#endif
#define grn_expr_parserARG_SDECL  efs_info *efsi ;
#define grn_expr_parserARG_PDECL , efs_info *efsi 
#define grn_expr_parserARG_PARAM ,efsi 
#define grn_expr_parserARG_FETCH  efs_info *efsi =yypParser->efsi ;
#define grn_expr_parserARG_STORE yypParser->efsi =efsi ;
#define grn_expr_parserCTX_SDECL
#define grn_expr_parserCTX_PDECL
#define grn_expr_parserCTX_PARAM
#define grn_expr_parserCTX_FETCH
#define grn_expr_parserCTX_STORE
#define YYNSTATE             154
#define YYNRULE              142
#define YYNRULE_WITH_ACTION  99
#define YYNTOKEN             79
#define YY_MAX_SHIFT         153
#define YY_MIN_SHIFTREDUCE   241
#define YY_MAX_SHIFTREDUCE   382
#define YY_ERROR_ACTION      383
#define YY_ACCEPT_ACTION     384
#define YY_NO_ACTION         385
#define YY_MIN_REDUCE        386
#define YY_MAX_REDUCE        527
/************* End control #defines *******************************************/
#define YY_NLOOKAHEAD ((int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])))

/* Define the yytestcase() macro to be a no-op if is not already defined
** otherwise.
**
** Applications can choose to define yytestcase() in the %include section
** to a macro that can assist in verifying code coverage.  For production
** code the yytestcase() macro should be turned off.  But it is useful
** for testing.
*/
#ifndef yytestcase
# define yytestcase(X)
#endif


/* Next are the tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N <= YY_MAX_SHIFT             Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   N between YY_MIN_SHIFTREDUCE       Shift to an arbitrary state then
**     and YY_MAX_SHIFTREDUCE           reduce by rule N-YY_MIN_SHIFTREDUCE.
**
**   N == YY_ERROR_ACTION               A syntax error has occurred.
**
**   N == YY_ACCEPT_ACTION              The parser accepts its input.
**
**   N == YY_NO_ACTION                  No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
**   N between YY_MIN_REDUCE            Reduce by rule N-YY_MIN_REDUCE
**     and YY_MAX_REDUCE
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as either:
**
**    (A)   N = yy_action[ yy_shift_ofst[S] + X ]
**    (B)   N = yy_default[S]
**
** The (A) formula is preferred.  The B formula is used instead if
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X.
**
** The formulas above are for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
**
*********** Begin parsing tables **********************************************/
#define YY_ACTTAB_COUNT (1864)
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   395,    3,   77,    4,  123,  123,  145,  386,  346,    2,
 /*    10 */    83,   58,   88,  138,    1,   83,   76,  384,   84,  120,
 /*    20 */   395,  395,  140,   84,   80,  120,  120,   95,  135,  134,
 /*    30 */   148,  147,  146,  129,   92,  110,  125,  111,  111,  111,
 /*    40 */    95,   80,  476,  142,   80,   80,  346,   79,  118,   89,
 /*    50 */    88,  153,   11,  390,   76,  456,  511,   71,   70,   57,
 /*    60 */    56,   55,   74,   73,   72,   69,   68,   66,   65,   64,
 /*    70 */   371,  372,  373,  374,  375,    8,  136,  522,  145,  118,
 /*    80 */   142,   80,  136,  136,   95,  135,  134,  148,  147,  146,
 /*    90 */   129,   92,  110,  125,  111,  111,  111,   95,   80,   32,
 /*   100 */    31,   80,   80,  488,  123,  123,  145,  346,    2,  378,
 /*   110 */    58,   88,  138,    1,  389,   76,   83,  127,   75,   63,
 /*   120 */    62,   83,   80,  127,  127,   95,  135,  134,  148,  147,
 /*   130 */   146,  129,   92,  110,  125,  111,  111,  111,   95,   80,
 /*   140 */   320,  393,   80,   80,    9,  523,   67,   23,  369,   78,
 /*   150 */   392,  316,  391,   82,   60,   59,   71,   70,   37,   36,
 /*   160 */    81,   74,   73,   72,   69,   68,   66,   65,   64,  371,
 /*   170 */   372,  373,  374,  375,    8,   54,   53,   52,   51,   50,
 /*   180 */    49,   48,   47,   46,   45,   44,   43,   42,   41,   40,
 /*   190 */    39,   38,   71,   70,  328,  489,  388,   74,   73,   72,
 /*   200 */    69,   68,   66,   65,   64,  371,  372,  373,  374,  375,
 /*   210 */     8,  119,    6,  329,   87,   80,  475,  475,   95,  135,
 /*   220 */   134,  148,  147,  146,  129,   92,  110,  125,  111,  111,
 /*   230 */   111,   95,   80,  387,  368,   80,   80,  249,    7,   29,
 /*   240 */    25,   29,  470,  117,  333,   80,  484,  484,   95,  135,
 /*   250 */   134,  148,  147,  146,  129,   92,  110,  125,  111,  111,
 /*   260 */   111,   95,   80,  309,  310,   80,   80,    9,  139,   67,
 /*   270 */   141,  369,   78,  332,   33,  480,  379,   24,   35,   26,
 /*   280 */    80,  475,  475,   95,  135,  134,  148,  147,  146,  129,
 /*   290 */    92,  110,  125,  111,  111,  111,   95,   80,    9,  312,
 /*   300 */    80,   80,  369,   78,   10,   34,  144,  472,  385,  385,
 /*   310 */   385,  385,  385,  385,  385,   71,   61,  487,  486,  385,
 /*   320 */    74,   73,   72,   69,   68,   66,   65,   64,  371,  372,
 /*   330 */   373,  374,  375,    8,    5,   29,  337,   80,  484,  484,
 /*   340 */    95,  135,  134,  148,  147,  146,  129,   92,  110,  125,
 /*   350 */   111,  111,  111,   95,   80,   29,  385,   80,   80,  371,
 /*   360 */   372,  373,  374,  375,    8,  385,   30,  481,   80,  467,
 /*   370 */   467,   95,  135,  134,  148,  147,  146,  129,   92,  110,
 /*   380 */   125,  111,  111,  111,   95,   80,  385,  385,   80,   80,
 /*   390 */    27,  385,  385,  385,  122,   80,  459,  459,   95,  135,
 /*   400 */   134,  148,  147,  146,  129,   92,  110,  125,  111,  111,
 /*   410 */   111,   95,   80,  127,  319,   80,   80,  124,   80,  127,
 /*   420 */   127,   95,  135,  134,  148,  147,  146,  129,   92,  110,
 /*   430 */   125,  111,  111,  111,   95,   80,  130,  385,   80,   80,
 /*   440 */   385,   80,  130,  130,   95,  135,  134,  148,  147,  146,
 /*   450 */   129,   92,  110,  125,  111,  111,  111,   95,   80,  136,
 /*   460 */   385,   80,   80,  385,   80,  136,  136,   95,  135,  134,
 /*   470 */   148,  147,  146,  129,   92,  110,  125,  111,  111,  111,
 /*   480 */    95,   80,  385,  385,   80,   80,    9,  385,   67,  385,
 /*   490 */   369,   78,   80,  408,  408,   95,  135,  134,  148,  147,
 /*   500 */   146,  129,   92,  110,  125,  111,  111,  111,   95,   80,
 /*   510 */   385,  385,   80,   80,  385,  385,   80,  407,  407,   95,
 /*   520 */   135,  134,  148,  147,  146,  129,   92,  110,  125,  111,
 /*   530 */   111,  111,   95,   80,   71,   70,   80,   80,  385,   74,
 /*   540 */    73,   72,   69,   68,   66,   65,   64,  371,  372,  373,
 /*   550 */   374,  375,    8,  385,    9,  338,   67,  385,  369,   78,
 /*   560 */    80,  406,  406,   95,  135,  134,  148,  147,  146,  129,
 /*   570 */    92,  110,  125,  111,  111,  111,   95,   80,  385,  385,
 /*   580 */    80,   80,  385,  385,   80,  405,  405,   95,  135,  134,
 /*   590 */   148,  147,  146,  129,   92,  110,  125,  111,  111,  111,
 /*   600 */    95,   80,   71,   70,   80,   80,  385,   74,   73,   72,
 /*   610 */    69,   68,   66,   65,   64,  371,  372,  137,  374,  375,
 /*   620 */     8,    9,  385,   67,  385,  369,   78,   80,  404,  404,
 /*   630 */    95,  135,  134,  148,  147,  146,  129,   92,  110,  125,
 /*   640 */   111,  111,  111,   95,   80,  385,  385,   80,   80,  385,
 /*   650 */   385,   80,  403,  403,   95,  135,  134,  148,  147,  146,
 /*   660 */   129,   92,  110,  125,  111,  111,  111,   95,   80,   71,
 /*   670 */    70,   80,   80,  385,   74,   73,   72,   69,   68,   66,
 /*   680 */    65,   64,  371,  372,  373,  374,  375,    8,   80,  402,
 /*   690 */   402,   95,  135,  134,  148,  147,  146,  129,   92,  110,
 /*   700 */   125,  111,  111,  111,   95,   80,  385,  385,   80,   80,
 /*   710 */   385,   80,  401,  401,   95,  135,  134,  148,  147,  146,
 /*   720 */   129,   92,  110,  125,  111,  111,  111,   95,   80,  385,
 /*   730 */   385,   80,   80,  385,  385,   80,  400,  400,   95,  135,
 /*   740 */   134,  148,  147,  146,  129,   92,  110,  125,  111,  111,
 /*   750 */   111,   95,   80,  385,  385,   80,   80,   80,  399,  399,
 /*   760 */    95,  135,  134,  148,  147,  146,  129,   92,  110,  125,
 /*   770 */   111,  111,  111,   95,   80,  385,  385,   80,   80,   80,
 /*   780 */   398,  398,   95,  135,  134,  148,  147,  146,  129,   92,
 /*   790 */   110,  125,  111,  111,  111,   95,   80,  385,  385,   80,
 /*   800 */    80,   80,  468,  468,   95,  135,  134,  148,  147,  146,
 /*   810 */   129,   92,  110,  125,  111,  111,  111,   95,   80,  385,
 /*   820 */   385,   80,   80,   80,  463,  463,   95,  135,  134,  148,
 /*   830 */   147,  146,  129,   92,  110,  125,  111,  111,  111,   95,
 /*   840 */    80,  385,  385,   80,   80,   80,  460,  460,   95,  135,
 /*   850 */   134,  148,  147,  146,  129,   92,  110,  125,  111,  111,
 /*   860 */   111,   95,   80,  385,  385,   80,   80,   80,  409,  409,
 /*   870 */    95,  135,  134,  148,  147,  146,  129,   92,  110,  125,
 /*   880 */   111,  111,  111,   95,   80,  385,  385,   80,   80,   80,
 /*   890 */   152,  152,   95,  135,  134,  148,  147,  146,  129,   92,
 /*   900 */   110,  125,  111,  111,  111,   95,   80,  385,  385,   80,
 /*   910 */    80,   80,  397,  397,   95,  135,  134,  148,  147,  146,
 /*   920 */   129,   92,  110,  125,  111,  111,  111,   95,   80,  385,
 /*   930 */   385,   80,   80,   80,  396,  396,   95,  135,  134,  148,
 /*   940 */   147,  146,  129,   92,  110,  125,  111,  111,  111,   95,
 /*   950 */    80,  385,  385,   80,   80,   80,  385,  385,  131,  385,
 /*   960 */   121,  148,  147,  146,  129,   92,  110,  125,  111,  111,
 /*   970 */   111,  131,   80,  385,  385,   80,   80,   80,  385,  385,
 /*   980 */   131,  385,  385,  143,  147,  146,  129,   92,  110,  125,
 /*   990 */   111,  111,  111,  131,   80,  385,  385,   80,   80,   80,
 /*  1000 */   385,  385,  131,  385,  385,  151,  147,  146,  129,   92,
 /*  1010 */   110,  125,  111,  111,  111,  131,   80,  385,  385,   80,
 /*  1020 */    80,   80,  385,  385,  131,  385,  385,  385,  150,  146,
 /*  1030 */   129,   92,  110,  125,  111,  111,  111,  131,   80,  385,
 /*  1040 */   385,   80,   80,   80,  385,  385,  131,  385,  385,  385,
 /*  1050 */   385,  149,  129,   92,  110,  125,  111,  111,  111,  131,
 /*  1060 */    80,  385,  385,   80,   80,   28,   22,   21,   20,   19,
 /*  1070 */    18,   17,   16,   15,   14,   13,   12,   80,  385,  385,
 /*  1080 */   131,  385,  385,  385,  385,  385,  133,   92,  110,  125,
 /*  1090 */   111,  111,  111,  131,   80,  385,  385,   80,   80,  385,
 /*  1100 */   385,  385,   80,  385,  385,  131,  385,  385,  385,  385,
 /*  1110 */   309,  310,   93,  110,  125,  111,  111,  111,  131,   80,
 /*  1120 */   385,   80,   80,   80,  131,  385,  385,  385,  385,  385,
 /*  1130 */   385,   94,  110,  125,  111,  111,  111,  131,   80,  385,
 /*  1140 */   385,   80,   80,   91,   90,   86,   85,  346,   79,  347,
 /*  1150 */    89,   88,  153,   11,  485,   76,  385,  385,   91,   90,
 /*  1160 */    86,   85,  346,   79,  385,   89,   88,  153,   11,  385,
 /*  1170 */    76,  385,  385,  385,   80,  385,  385,  131,  385,  385,
 /*  1180 */   385,  385,  385,  385,  385,   96,  125,  111,  111,  111,
 /*  1190 */   131,   80,  385,   80,   80,   80,  131,  385,  385,  385,
 /*  1200 */   385,  385,  385,  385,   97,  125,  111,  111,  111,  131,
 /*  1210 */    80,  385,   80,   80,   80,  131,  385,  385,  385,  385,
 /*  1220 */   385,  385,  385,   98,  125,  111,  111,  111,  131,   80,
 /*  1230 */   385,   80,   80,   80,  131,  385,  385,  385,  385,  385,
 /*  1240 */   385,  385,   99,  125,  111,  111,  111,  131,   80,  385,
 /*  1250 */    80,   80,   80,  131,  385,  385,  385,  385,  385,  385,
 /*  1260 */   385,  100,  125,  111,  111,  111,  131,   80,  385,  385,
 /*  1270 */    80,   80,  385,   80,  385,  385,  131,  385,  385,  385,
 /*  1280 */   385,  385,  385,  385,  101,  125,  111,  111,  111,  131,
 /*  1290 */    80,  385,   80,   80,   80,  131,  385,  385,  385,  385,
 /*  1300 */   385,  385,  385,  102,  125,  111,  111,  111,  131,   80,
 /*  1310 */   385,   80,   80,   80,  131,  385,  385,  385,  385,  385,
 /*  1320 */   385,  385,  103,  125,  111,  111,  111,  131,   80,  385,
 /*  1330 */    80,   80,   80,  131,  385,  385,  385,  385,  385,  385,
 /*  1340 */   385,  104,  125,  111,  111,  111,  131,   80,  385,   80,
 /*  1350 */    80,   80,  131,  385,  385,  385,  385,  385,  385,  385,
 /*  1360 */   105,  125,  111,  111,  111,  131,   80,  385,  385,   80,
 /*  1370 */    80,  385,   80,  385,  385,  131,  385,  385,  385,  385,
 /*  1380 */   385,  385,  385,  106,  125,  111,  111,  111,  131,   80,
 /*  1390 */   385,   80,   80,   80,  131,  385,  385,  385,  385,  385,
 /*  1400 */   385,  385,  107,  125,  111,  111,  111,  131,   80,  385,
 /*  1410 */    80,   80,   80,  131,  385,  385,  385,  385,  385,  385,
 /*  1420 */   385,  108,  125,  111,  111,  111,  131,   80,  385,   80,
 /*  1430 */    80,   80,  131,  385,  385,  385,  385,  385,  385,  385,
 /*  1440 */   109,  125,  111,  111,  111,  131,   80,  385,   80,   80,
 /*  1450 */    80,  131,  385,  385,  385,  385,  385,  385,  385,  112,
 /*  1460 */   125,  111,  111,  111,  131,   80,  385,  385,   80,   80,
 /*  1470 */   385,   80,  385,  385,  131,  385,  385,  385,  385,  385,
 /*  1480 */   385,  385,  114,  125,  111,  111,  111,  131,   80,  385,
 /*  1490 */    80,   80,   80,  131,  385,  385,  385,  385,  385,  385,
 /*  1500 */   385,  116,  125,  111,  111,  111,  131,   80,  385,   80,
 /*  1510 */    80,   80,  131,  385,  385,  385,  385,  385,  385,  385,
 /*  1520 */   385,  126,  111,  111,  111,  131,   80,  385,   80,   80,
 /*  1530 */    80,  131,  385,  385,  385,  385,  385,  385,  385,  385,
 /*  1540 */   128,  111,  111,  111,  131,   80,  385,   80,   80,   80,
 /*  1550 */   131,  385,  385,  385,  385,  385,  385,  385,  385,  132,
 /*  1560 */   111,  111,  111,  131,   80,  385,  385,   80,   80,  391,
 /*  1570 */    80,  385,  385,  131,  385,  385,  385,  385,  385,   80,
 /*  1580 */   385,  385,  131,  385,  450,  450,  131,   80,  385,  385,
 /*  1590 */    80,   80,  113,  113,  113,  131,   80,  385,   80,   80,
 /*  1600 */    80,  131,  385,  385,  385,  385,  385,  385,  385,  385,
 /*  1610 */   385,  115,  115,  115,  131,   80,  385,   80,   80,   80,
 /*  1620 */   131,  385,  385,  385,  385,  385,  385,  385,  385,  385,
 /*  1630 */   385,  447,  447,  131,   80,  385,   80,   80,   80,  131,
 /*  1640 */   385,  385,  385,  385,  385,  385,  385,  385,  385,  385,
 /*  1650 */   442,  442,  131,   80,  385,   80,   80,   80,  131,  385,
 /*  1660 */   385,  385,  385,  385,  385,  385,  385,  385,  385,  441,
 /*  1670 */   441,  131,   80,  385,   80,   80,   80,  131,  385,  385,
 /*  1680 */   385,  385,   80,  385,  385,  131,  385,  385,  453,  453,
 /*  1690 */   131,   80,  385,  385,   80,   80,  452,  452,  131,   80,
 /*  1700 */   385,   80,   80,   80,  131,  385,  385,  385,  385,  385,
 /*  1710 */   385,  385,  385,  385,  385,  451,  451,  131,   80,  385,
 /*  1720 */    80,   80,   80,  131,  385,  385,  385,  385,  385,  385,
 /*  1730 */   385,  385,  385,  385,  450,  450,  131,   80,  385,   80,
 /*  1740 */    80,   80,  131,  385,  385,  385,  385,  385,  385,  385,
 /*  1750 */   385,  385,  385,  449,  449,  131,   80,  385,   80,   80,
 /*  1760 */    80,  131,  385,  385,  385,  385,  385,  385,  385,  385,
 /*  1770 */   385,  385,  448,  448,  131,   80,  385,   80,   80,   80,
 /*  1780 */   131,  385,  385,  385,  385,   80,  385,  385,  131,  385,
 /*  1790 */   385,  446,  446,  131,   80,  385,  385,   80,   80,  445,
 /*  1800 */   445,  131,   80,  385,   80,   80,   80,  131,  385,  385,
 /*  1810 */   385,  385,  385,  385,  385,  385,  385,  385,  444,  444,
 /*  1820 */   131,   80,  385,   80,   80,   80,  131,  385,  385,  385,
 /*  1830 */   385,  385,  385,  385,  385,  385,  385,  443,  443,  131,
 /*  1840 */    80,  385,   80,   80,   80,  131,  385,  385,  385,  385,
 /*  1850 */   385,  385,  385,  385,  385,  385,  440,  440,  131,   80,
 /*  1860 */   385,  385,   80,   80,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    87,    1,    2,    3,  110,  111,  112,   86,    8,    9,
 /*    10 */    81,   11,   12,   13,   14,   86,   16,   80,   81,   82,
 /*    20 */   107,  108,   13,   86,   87,   88,   89,   90,   91,   92,
 /*    30 */    93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
 /*    40 */   103,  104,  115,  116,  107,  108,    8,    9,   84,   11,
 /*    50 */    12,   13,   14,   86,   16,  105,  106,   57,   58,   54,
 /*    60 */    55,   56,   62,   63,   64,   65,   66,   67,   68,   69,
 /*    70 */    70,   71,   72,   73,   74,   75,   82,  111,  112,  115,
 /*    80 */   116,   87,   88,   89,   90,   91,   92,   93,   94,   95,
 /*    90 */    96,   97,   98,   99,  100,  101,  102,  103,  104,    4,
 /*   100 */     5,  107,  108,    0,  110,  111,  112,    8,    9,   72,
 /*   110 */    11,   12,   13,   14,   86,   16,   81,   82,   59,   60,
 /*   120 */    61,   86,   87,   88,   89,   90,   91,   92,   93,   94,
 /*   130 */    95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
 /*   140 */    10,   86,  107,  108,    9,   31,   11,   17,   13,   14,
 /*   150 */    86,   15,   86,   17,   57,   58,   57,   58,   35,   36,
 /*   160 */    57,   62,   63,   64,   65,   66,   67,   68,   69,   70,
 /*   170 */    71,   72,   73,   74,   75,   37,   38,   39,   40,   41,
 /*   180 */    42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
 /*   190 */    52,   53,   57,   58,   59,    0,   86,   62,   63,   64,
 /*   200 */    65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
 /*   210 */    75,   83,   17,   78,   12,   87,   88,   89,   90,   91,
 /*   220 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   230 */   102,  103,  104,   86,   10,  107,  108,   15,    9,   17,
 /*   240 */    17,   17,  114,   85,   72,   87,   88,   89,   90,   91,
 /*   250 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   260 */   102,  103,  104,   63,   64,  107,  108,    9,   42,   11,
 /*   270 */    59,   13,   14,   70,   32,  117,   13,   31,   34,   31,
 /*   280 */    87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
 /*   290 */    97,   98,   99,  100,  101,  102,  103,  104,    9,   76,
 /*   300 */   107,  108,   13,   14,   75,   33,   77,  114,  118,  118,
 /*   310 */   118,  118,  118,  118,  118,   57,   58,    0,    0,  118,
 /*   320 */    62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
 /*   330 */    72,   73,   74,   75,   17,   17,   78,   87,   88,   89,
 /*   340 */    90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
 /*   350 */   100,  101,  102,  103,  104,   17,  118,  107,  108,   70,
 /*   360 */    71,   72,   73,   74,   75,  118,    6,  117,   87,   88,
 /*   370 */    89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
 /*   380 */    99,  100,  101,  102,  103,  104,  118,  118,  107,  108,
 /*   390 */    30,  118,  118,  118,  113,   87,   88,   89,   90,   91,
 /*   400 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   410 */   102,  103,  104,   82,   76,  107,  108,  109,   87,   88,
 /*   420 */    89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
 /*   430 */    99,  100,  101,  102,  103,  104,   82,  118,  107,  108,
 /*   440 */   118,   87,   88,   89,   90,   91,   92,   93,   94,   95,
 /*   450 */    96,   97,   98,   99,  100,  101,  102,  103,  104,   82,
 /*   460 */   118,  107,  108,  118,   87,   88,   89,   90,   91,   92,
 /*   470 */    93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
 /*   480 */   103,  104,  118,  118,  107,  108,    9,  118,   11,  118,
 /*   490 */    13,   14,   87,   88,   89,   90,   91,   92,   93,   94,
 /*   500 */    95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
 /*   510 */   118,  118,  107,  108,  118,  118,   87,   88,   89,   90,
 /*   520 */    91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
 /*   530 */   101,  102,  103,  104,   57,   58,  107,  108,  118,   62,
 /*   540 */    63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
 /*   550 */    73,   74,   75,  118,    9,   78,   11,  118,   13,   14,
 /*   560 */    87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
 /*   570 */    97,   98,   99,  100,  101,  102,  103,  104,  118,  118,
 /*   580 */   107,  108,  118,  118,   87,   88,   89,   90,   91,   92,
 /*   590 */    93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
 /*   600 */   103,  104,   57,   58,  107,  108,  118,   62,   63,   64,
 /*   610 */    65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
 /*   620 */    75,    9,  118,   11,  118,   13,   14,   87,   88,   89,
 /*   630 */    90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
 /*   640 */   100,  101,  102,  103,  104,  118,  118,  107,  108,  118,
 /*   650 */   118,   87,   88,   89,   90,   91,   92,   93,   94,   95,
 /*   660 */    96,   97,   98,   99,  100,  101,  102,  103,  104,   57,
 /*   670 */    58,  107,  108,  118,   62,   63,   64,   65,   66,   67,
 /*   680 */    68,   69,   70,   71,   72,   73,   74,   75,   87,   88,
 /*   690 */    89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
 /*   700 */    99,  100,  101,  102,  103,  104,  118,  118,  107,  108,
 /*   710 */   118,   87,   88,   89,   90,   91,   92,   93,   94,   95,
 /*   720 */    96,   97,   98,   99,  100,  101,  102,  103,  104,  118,
 /*   730 */   118,  107,  108,  118,  118,   87,   88,   89,   90,   91,
 /*   740 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   750 */   102,  103,  104,  118,  118,  107,  108,   87,   88,   89,
 /*   760 */    90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
 /*   770 */   100,  101,  102,  103,  104,  118,  118,  107,  108,   87,
 /*   780 */    88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
 /*   790 */    98,   99,  100,  101,  102,  103,  104,  118,  118,  107,
 /*   800 */   108,   87,   88,   89,   90,   91,   92,   93,   94,   95,
 /*   810 */    96,   97,   98,   99,  100,  101,  102,  103,  104,  118,
 /*   820 */   118,  107,  108,   87,   88,   89,   90,   91,   92,   93,
 /*   830 */    94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
 /*   840 */   104,  118,  118,  107,  108,   87,   88,   89,   90,   91,
 /*   850 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   860 */   102,  103,  104,  118,  118,  107,  108,   87,   88,   89,
 /*   870 */    90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
 /*   880 */   100,  101,  102,  103,  104,  118,  118,  107,  108,   87,
 /*   890 */    88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
 /*   900 */    98,   99,  100,  101,  102,  103,  104,  118,  118,  107,
 /*   910 */   108,   87,   88,   89,   90,   91,   92,   93,   94,   95,
 /*   920 */    96,   97,   98,   99,  100,  101,  102,  103,  104,  118,
 /*   930 */   118,  107,  108,   87,   88,   89,   90,   91,   92,   93,
 /*   940 */    94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
 /*   950 */   104,  118,  118,  107,  108,   87,  118,  118,   90,  118,
 /*   960 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   970 */   102,  103,  104,  118,  118,  107,  108,   87,  118,  118,
 /*   980 */    90,  118,  118,   93,   94,   95,   96,   97,   98,   99,
 /*   990 */   100,  101,  102,  103,  104,  118,  118,  107,  108,   87,
 /*  1000 */   118,  118,   90,  118,  118,   93,   94,   95,   96,   97,
 /*  1010 */    98,   99,  100,  101,  102,  103,  104,  118,  118,  107,
 /*  1020 */   108,   87,  118,  118,   90,  118,  118,  118,   94,   95,
 /*  1030 */    96,   97,   98,   99,  100,  101,  102,  103,  104,  118,
 /*  1040 */   118,  107,  108,   87,  118,  118,   90,  118,  118,  118,
 /*  1050 */   118,   95,   96,   97,   98,   99,  100,  101,  102,  103,
 /*  1060 */   104,  118,  118,  107,  108,   18,   19,   20,   21,   22,
 /*  1070 */    23,   24,   25,   26,   27,   28,   29,   87,  118,  118,
 /*  1080 */    90,  118,  118,  118,  118,  118,   96,   97,   98,   99,
 /*  1090 */   100,  101,  102,  103,  104,  118,  118,  107,  108,  118,
 /*  1100 */   118,  118,   87,  118,  118,   90,  118,  118,  118,  118,
 /*  1110 */    63,   64,   97,   98,   99,  100,  101,  102,  103,  104,
 /*  1120 */   118,   87,  107,  108,   90,  118,  118,  118,  118,  118,
 /*  1130 */   118,   97,   98,   99,  100,  101,  102,  103,  104,  118,
 /*  1140 */   118,  107,  108,    4,    5,    6,    7,    8,    9,   10,
 /*  1150 */    11,   12,   13,   14,    0,   16,  118,  118,    4,    5,
 /*  1160 */     6,    7,    8,    9,  118,   11,   12,   13,   14,  118,
 /*  1170 */    16,  118,  118,  118,   87,  118,  118,   90,  118,  118,
 /*  1180 */   118,  118,  118,  118,  118,   98,   99,  100,  101,  102,
 /*  1190 */   103,  104,  118,   87,  107,  108,   90,  118,  118,  118,
 /*  1200 */   118,  118,  118,  118,   98,   99,  100,  101,  102,  103,
 /*  1210 */   104,  118,   87,  107,  108,   90,  118,  118,  118,  118,
 /*  1220 */   118,  118,  118,   98,   99,  100,  101,  102,  103,  104,
 /*  1230 */   118,   87,  107,  108,   90,  118,  118,  118,  118,  118,
 /*  1240 */   118,  118,   98,   99,  100,  101,  102,  103,  104,  118,
 /*  1250 */    87,  107,  108,   90,  118,  118,  118,  118,  118,  118,
 /*  1260 */   118,   98,   99,  100,  101,  102,  103,  104,  118,  118,
 /*  1270 */   107,  108,  118,   87,  118,  118,   90,  118,  118,  118,
 /*  1280 */   118,  118,  118,  118,   98,   99,  100,  101,  102,  103,
 /*  1290 */   104,  118,   87,  107,  108,   90,  118,  118,  118,  118,
 /*  1300 */   118,  118,  118,   98,   99,  100,  101,  102,  103,  104,
 /*  1310 */   118,   87,  107,  108,   90,  118,  118,  118,  118,  118,
 /*  1320 */   118,  118,   98,   99,  100,  101,  102,  103,  104,  118,
 /*  1330 */    87,  107,  108,   90,  118,  118,  118,  118,  118,  118,
 /*  1340 */   118,   98,   99,  100,  101,  102,  103,  104,  118,   87,
 /*  1350 */   107,  108,   90,  118,  118,  118,  118,  118,  118,  118,
 /*  1360 */    98,   99,  100,  101,  102,  103,  104,  118,  118,  107,
 /*  1370 */   108,  118,   87,  118,  118,   90,  118,  118,  118,  118,
 /*  1380 */   118,  118,  118,   98,   99,  100,  101,  102,  103,  104,
 /*  1390 */   118,   87,  107,  108,   90,  118,  118,  118,  118,  118,
 /*  1400 */   118,  118,   98,   99,  100,  101,  102,  103,  104,  118,
 /*  1410 */    87,  107,  108,   90,  118,  118,  118,  118,  118,  118,
 /*  1420 */   118,   98,   99,  100,  101,  102,  103,  104,  118,   87,
 /*  1430 */   107,  108,   90,  118,  118,  118,  118,  118,  118,  118,
 /*  1440 */    98,   99,  100,  101,  102,  103,  104,  118,   87,  107,
 /*  1450 */   108,   90,  118,  118,  118,  118,  118,  118,  118,   98,
 /*  1460 */    99,  100,  101,  102,  103,  104,  118,  118,  107,  108,
 /*  1470 */   118,   87,  118,  118,   90,  118,  118,  118,  118,  118,
 /*  1480 */   118,  118,   98,   99,  100,  101,  102,  103,  104,  118,
 /*  1490 */    87,  107,  108,   90,  118,  118,  118,  118,  118,  118,
 /*  1500 */   118,   98,   99,  100,  101,  102,  103,  104,  118,   87,
 /*  1510 */   107,  108,   90,  118,  118,  118,  118,  118,  118,  118,
 /*  1520 */   118,   99,  100,  101,  102,  103,  104,  118,   87,  107,
 /*  1530 */   108,   90,  118,  118,  118,  118,  118,  118,  118,  118,
 /*  1540 */    99,  100,  101,  102,  103,  104,  118,   87,  107,  108,
 /*  1550 */    90,  118,  118,  118,  118,  118,  118,  118,  118,   99,
 /*  1560 */   100,  101,  102,  103,  104,  118,  118,  107,  108,   86,
 /*  1570 */    87,  118,  118,   90,  118,  118,  118,  118,  118,   87,
 /*  1580 */   118,  118,   90,  118,  101,  102,  103,  104,  118,  118,
 /*  1590 */   107,  108,  100,  101,  102,  103,  104,  118,   87,  107,
 /*  1600 */   108,   90,  118,  118,  118,  118,  118,  118,  118,  118,
 /*  1610 */   118,  100,  101,  102,  103,  104,  118,   87,  107,  108,
 /*  1620 */    90,  118,  118,  118,  118,  118,  118,  118,  118,  118,
 /*  1630 */   118,  101,  102,  103,  104,  118,   87,  107,  108,   90,
 /*  1640 */   118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
 /*  1650 */   101,  102,  103,  104,  118,   87,  107,  108,   90,  118,
 /*  1660 */   118,  118,  118,  118,  118,  118,  118,  118,  118,  101,
 /*  1670 */   102,  103,  104,  118,   87,  107,  108,   90,  118,  118,
 /*  1680 */   118,  118,   87,  118,  118,   90,  118,  118,  101,  102,
 /*  1690 */   103,  104,  118,  118,  107,  108,  101,  102,  103,  104,
 /*  1700 */   118,   87,  107,  108,   90,  118,  118,  118,  118,  118,
 /*  1710 */   118,  118,  118,  118,  118,  101,  102,  103,  104,  118,
 /*  1720 */    87,  107,  108,   90,  118,  118,  118,  118,  118,  118,
 /*  1730 */   118,  118,  118,  118,  101,  102,  103,  104,  118,   87,
 /*  1740 */   107,  108,   90,  118,  118,  118,  118,  118,  118,  118,
 /*  1750 */   118,  118,  118,  101,  102,  103,  104,  118,   87,  107,
 /*  1760 */   108,   90,  118,  118,  118,  118,  118,  118,  118,  118,
 /*  1770 */   118,  118,  101,  102,  103,  104,  118,   87,  107,  108,
 /*  1780 */    90,  118,  118,  118,  118,   87,  118,  118,   90,  118,
 /*  1790 */   118,  101,  102,  103,  104,  118,  118,  107,  108,  101,
 /*  1800 */   102,  103,  104,  118,   87,  107,  108,   90,  118,  118,
 /*  1810 */   118,  118,  118,  118,  118,  118,  118,  118,  101,  102,
 /*  1820 */   103,  104,  118,   87,  107,  108,   90,  118,  118,  118,
 /*  1830 */   118,  118,  118,  118,  118,  118,  118,  101,  102,  103,
 /*  1840 */   104,  118,   87,  107,  108,   90,  118,  118,  118,  118,
 /*  1850 */   118,  118,  118,  118,  118,  118,  101,  102,  103,  104,
 /*  1860 */   118,  118,  107,  108,   79,   79,   79,   79,   79,   79,
 /*  1870 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1880 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1890 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1900 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1910 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1920 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1930 */    79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
 /*  1940 */    79,   79,   79,
};
#define YY_SHIFT_COUNT    (153)
#define YY_SHIFT_MIN      (0)
#define YY_SHIFT_MAX      (1154)
static const unsigned short int yy_shift_ofst[] = {
 /*     0 */     0,  545,   99,  135,  258,  135,  258,  612,  612,  612,
 /*    10 */   612,  612,  612,  612,  612,  612,  612,  612,  612,  612,
 /*    20 */   612,  612,  612,  612,  612,  612,  612,  612,  612,  612,
 /*    30 */   612,  612,  612,  612,  612,  612,  612,  612,  612,  612,
 /*    40 */   612,  612,  612,  612,  612,  612,  612,  612,  612,  612,
 /*    50 */   612,  612,  612,  612,  612,  612,  612,  612,   99,  612,
 /*    60 */   612,  477,  612,  612,  612,  612,  612,  612,  612,  612,
 /*    70 */   612,  612,  612,  612,  612,  612,  289,    9,   37,   38,
 /*    80 */   229,    9,   37, 1139, 1154,   38,   38,   38,   38,   38,
 /*    90 */    38,   38,  138,  138,  138, 1047,    5,    5,    5,    5,
 /*   100 */     5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
 /*   110 */     5,   59,    5,   59,    5,   59,    5,  195,  103,  317,
 /*   120 */   318,   95,  130,  136,  223,   97,   97,  224,   97,  123,
 /*   130 */   338,  200,   97,  123,   95,  360,  222,  114,  202,  172,
 /*   140 */   226,  203,  211,  242,  263,  246,  244,  272,  242,  244,
 /*   150 */   272,  242,  248,  202,
};
#define YY_REDUCE_COUNT (91)
#define YY_REDUCE_MIN   (-106)
#define YY_REDUCE_MAX   (1755)
static const short yy_reduce_ofst[] = {
 /*     0 */   -63,   -6,   35,  128,  158,  193,  250,  281,  308,  331,
 /*    10 */   354,  377,  405,  429,  473,  497,  540,  564,  601,  624,
 /*    20 */   648,  670,  692,  714,  736,  758,  780,  802,  824,  846,
 /*    30 */   868,  890,  912,  934,  956,  990, 1015, 1034, 1087, 1106,
 /*    40 */  1125, 1144, 1163, 1186, 1205, 1224, 1243, 1262, 1285, 1304,
 /*    50 */  1323, 1342, 1361, 1384, 1403, 1422, 1441, 1460, 1483, 1492,
 /*    60 */  1511, 1530, 1549, 1568, 1587, 1595, 1614, 1633, 1652, 1671,
 /*    70 */  1530, 1690, 1698, 1717, 1736, 1755,  -87,  -36, -106,  -71,
 /*    80 */   -50,  -73,  -34,  -79,  -79,  -33,   28,   55,   64,   66,
 /*    90 */   110,  147,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   383,  462,  383,  469,  479,  471,  383,  466,  458,  383,
 /*    10 */   383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    20 */   383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    30 */   383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    40 */   383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    50 */   383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    60 */   383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    70 */   383,  383,  383,  383,  383,  383,  383,  525,  462,  383,
 /*    80 */   509,  383,  383,  383,  383,  383,  383,  383,  383,  383,
 /*    90 */   383,  383,  501,  417,  416,  507,  434,  433,  432,  431,
 /*   100 */   430,  429,  428,  427,  426,  425,  424,  423,  422,  421,
 /*   110 */   502,  504,  420,  439,  419,  438,  418,  383,  383,  383,
 /*   120 */   383,  410,  383,  383,  383,  503,  437,  383,  436,  500,
 /*   130 */   383,  507,  435,  415,  496,  495,  383,  518,  514,  383,
 /*   140 */   383,  383,  527,  412,  383,  383,  499,  498,  497,  414,
 /*   150 */   413,  411,  383,  383,
};
/********** End of lemon-generated parsing tables *****************************/

/* The next table maps tokens (terminal symbols) into fallback tokens.  
** If a construct like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammar, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
**
** This feature can be used, for example, to cause some keywords in a language
** to revert to identifiers if they keyword does not apply in the context where
** it appears.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
**
** After the "shift" half of a SHIFTREDUCE action, the stateno field
** actually contains the reduce action for the second half of the
** SHIFTREDUCE.
*/
struct yyStackEntry {
  YYACTIONTYPE stateno;  /* The state-number, or reduce action in SHIFTREDUCE */
  YYCODETYPE major;      /* The major token value.  This is the code
                         ** number for the token at this stack level */
  YYMINORTYPE minor;     /* The user-supplied minor token value.  This
                         ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  yyStackEntry *yytos;          /* Pointer to top element of the stack */
#ifdef YYTRACKMAXSTACKDEPTH
  int yyhwm;                    /* High-water mark of the stack */
#endif
#ifndef YYNOERRORRECOVERY
  int yyerrcnt;                 /* Shifts left before out of the error */
#endif
  grn_expr_parserARG_SDECL                /* A place to hold %extra_argument */
  grn_expr_parserCTX_SDECL                /* A place to hold %extra_context */
#if YYSTACKDEPTH<=0
  int yystksz;                  /* Current side of the stack */
  yyStackEntry *yystack;        /* The parser's stack */
  yyStackEntry yystk0;          /* First stack entry */
#else
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
  yyStackEntry *yystackEnd;            /* Last entry in the stack */
#endif
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
#include <assert.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void grn_expr_parserTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#if defined(YYCOVERAGE) || !defined(NDEBUG)
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  /*    0 */ "$",
  /*    1 */ "START_OUTPUT_COLUMNS",
  /*    2 */ "START_ADJUSTER",
  /*    3 */ "START_SORT_KEYS",
  /*    4 */ "LOGICAL_AND",
  /*    5 */ "LOGICAL_AND_NOT",
  /*    6 */ "LOGICAL_OR",
  /*    7 */ "NEGATIVE",
  /*    8 */ "QSTRING",
  /*    9 */ "PARENL",
  /*   10 */ "PARENR",
  /*   11 */ "ADJUST",
  /*   12 */ "RELATIVE_OP",
  /*   13 */ "IDENTIFIER",
  /*   14 */ "BRACEL",
  /*   15 */ "BRACER",
  /*   16 */ "EVAL",
  /*   17 */ "COMMA",
  /*   18 */ "ASSIGN",
  /*   19 */ "STAR_ASSIGN",
  /*   20 */ "SLASH_ASSIGN",
  /*   21 */ "MOD_ASSIGN",
  /*   22 */ "PLUS_ASSIGN",
  /*   23 */ "MINUS_ASSIGN",
  /*   24 */ "SHIFTL_ASSIGN",
  /*   25 */ "SHIFTR_ASSIGN",
  /*   26 */ "SHIFTRR_ASSIGN",
  /*   27 */ "AND_ASSIGN",
  /*   28 */ "XOR_ASSIGN",
  /*   29 */ "OR_ASSIGN",
  /*   30 */ "QUESTION",
  /*   31 */ "COLON",
  /*   32 */ "BITWISE_OR",
  /*   33 */ "BITWISE_XOR",
  /*   34 */ "BITWISE_AND",
  /*   35 */ "EQUAL",
  /*   36 */ "NOT_EQUAL",
  /*   37 */ "LESS",
  /*   38 */ "GREATER",
  /*   39 */ "LESS_EQUAL",
  /*   40 */ "GREATER_EQUAL",
  /*   41 */ "IN",
  /*   42 */ "MATCH",
  /*   43 */ "NEAR",
  /*   44 */ "NEAR2",
  /*   45 */ "NEAR_PHRASE",
  /*   46 */ "ORDERED_NEAR_PHRASE",
  /*   47 */ "SIMILAR",
  /*   48 */ "TERM_EXTRACT",
  /*   49 */ "QUORUM",
  /*   50 */ "LCP",
  /*   51 */ "PREFIX",
  /*   52 */ "SUFFIX",
  /*   53 */ "REGEXP",
  /*   54 */ "SHIFTL",
  /*   55 */ "SHIFTR",
  /*   56 */ "SHIFTRR",
  /*   57 */ "PLUS",
  /*   58 */ "MINUS",
  /*   59 */ "STAR",
  /*   60 */ "SLASH",
  /*   61 */ "MOD",
  /*   62 */ "DELETE",
  /*   63 */ "INCR",
  /*   64 */ "DECR",
  /*   65 */ "NOT",
  /*   66 */ "BITWISE_NOT",
  /*   67 */ "EXACT",
  /*   68 */ "PARTIAL",
  /*   69 */ "UNSPLIT",
  /*   70 */ "DECIMAL",
  /*   71 */ "HEX_INTEGER",
  /*   72 */ "STRING",
  /*   73 */ "BOOLEAN",
  /*   74 */ "NULL",
  /*   75 */ "BRACKETL",
  /*   76 */ "BRACKETR",
  /*   77 */ "DOT",
  /*   78 */ "NONEXISTENT_COLUMN",
  /*   79 */ "suppress_unused_variable_warning",
  /*   80 */ "input",
  /*   81 */ "query",
  /*   82 */ "expression",
  /*   83 */ "output_columns",
  /*   84 */ "adjuster",
  /*   85 */ "sort_keys",
  /*   86 */ "query_element",
  /*   87 */ "primary_expression",
  /*   88 */ "assignment_expression",
  /*   89 */ "conditional_expression",
  /*   90 */ "lefthand_side_expression",
  /*   91 */ "logical_or_expression",
  /*   92 */ "logical_and_expression",
  /*   93 */ "bitwise_or_expression",
  /*   94 */ "bitwise_xor_expression",
  /*   95 */ "bitwise_and_expression",
  /*   96 */ "equality_expression",
  /*   97 */ "relational_expression",
  /*   98 */ "shift_expression",
  /*   99 */ "additive_expression",
  /*  100 */ "multiplicative_expression",
  /*  101 */ "unary_expression",
  /*  102 */ "postfix_expression",
  /*  103 */ "call_expression",
  /*  104 */ "member_expression",
  /*  105 */ "arguments",
  /*  106 */ "member_expression_part",
  /*  107 */ "object_literal",
  /*  108 */ "array_literal",
  /*  109 */ "element_list",
  /*  110 */ "property_name_and_value_list",
  /*  111 */ "property_name_and_value",
  /*  112 */ "property_name",
  /*  113 */ "argument_list",
  /*  114 */ "output_column",
  /*  115 */ "adjust_expression",
  /*  116 */ "adjust_match_expression",
  /*  117 */ "sort_key",
};
#endif /* defined(YYCOVERAGE) || !defined(NDEBUG) */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "query ::= query query_element",
 /*   1 */ "query ::= query LOGICAL_AND query_element",
 /*   2 */ "query ::= query LOGICAL_AND_NOT query_element",
 /*   3 */ "query ::= query LOGICAL_OR query_element",
 /*   4 */ "query ::= query NEGATIVE query_element",
 /*   5 */ "query_element ::= ADJUST query_element",
 /*   6 */ "query_element ::= RELATIVE_OP query_element",
 /*   7 */ "query_element ::= IDENTIFIER RELATIVE_OP query_element",
 /*   8 */ "query_element ::= BRACEL expression BRACER",
 /*   9 */ "query_element ::= EVAL primary_expression",
 /*  10 */ "expression ::= expression COMMA assignment_expression",
 /*  11 */ "assignment_expression ::= lefthand_side_expression ASSIGN assignment_expression",
 /*  12 */ "assignment_expression ::= lefthand_side_expression STAR_ASSIGN assignment_expression",
 /*  13 */ "assignment_expression ::= lefthand_side_expression SLASH_ASSIGN assignment_expression",
 /*  14 */ "assignment_expression ::= lefthand_side_expression MOD_ASSIGN assignment_expression",
 /*  15 */ "assignment_expression ::= lefthand_side_expression PLUS_ASSIGN assignment_expression",
 /*  16 */ "assignment_expression ::= lefthand_side_expression MINUS_ASSIGN assignment_expression",
 /*  17 */ "assignment_expression ::= lefthand_side_expression SHIFTL_ASSIGN assignment_expression",
 /*  18 */ "assignment_expression ::= lefthand_side_expression SHIFTR_ASSIGN assignment_expression",
 /*  19 */ "assignment_expression ::= lefthand_side_expression SHIFTRR_ASSIGN assignment_expression",
 /*  20 */ "assignment_expression ::= lefthand_side_expression AND_ASSIGN assignment_expression",
 /*  21 */ "assignment_expression ::= lefthand_side_expression XOR_ASSIGN assignment_expression",
 /*  22 */ "assignment_expression ::= lefthand_side_expression OR_ASSIGN assignment_expression",
 /*  23 */ "conditional_expression ::= logical_or_expression QUESTION assignment_expression COLON assignment_expression",
 /*  24 */ "logical_or_expression ::= logical_or_expression LOGICAL_OR logical_and_expression",
 /*  25 */ "logical_and_expression ::= logical_and_expression LOGICAL_AND bitwise_or_expression",
 /*  26 */ "logical_and_expression ::= logical_and_expression LOGICAL_AND_NOT bitwise_or_expression",
 /*  27 */ "bitwise_or_expression ::= bitwise_or_expression BITWISE_OR bitwise_xor_expression",
 /*  28 */ "bitwise_xor_expression ::= bitwise_xor_expression BITWISE_XOR bitwise_and_expression",
 /*  29 */ "bitwise_and_expression ::= bitwise_and_expression BITWISE_AND equality_expression",
 /*  30 */ "equality_expression ::= equality_expression EQUAL relational_expression",
 /*  31 */ "equality_expression ::= equality_expression NOT_EQUAL relational_expression",
 /*  32 */ "relational_expression ::= relational_expression LESS shift_expression",
 /*  33 */ "relational_expression ::= relational_expression GREATER shift_expression",
 /*  34 */ "relational_expression ::= relational_expression LESS_EQUAL shift_expression",
 /*  35 */ "relational_expression ::= relational_expression GREATER_EQUAL shift_expression",
 /*  36 */ "relational_expression ::= relational_expression IN shift_expression",
 /*  37 */ "relational_expression ::= relational_expression MATCH shift_expression",
 /*  38 */ "relational_expression ::= relational_expression NEAR shift_expression",
 /*  39 */ "relational_expression ::= relational_expression NEAR2 shift_expression",
 /*  40 */ "relational_expression ::= relational_expression NEAR_PHRASE shift_expression",
 /*  41 */ "relational_expression ::= relational_expression ORDERED_NEAR_PHRASE shift_expression",
 /*  42 */ "relational_expression ::= relational_expression SIMILAR shift_expression",
 /*  43 */ "relational_expression ::= relational_expression TERM_EXTRACT shift_expression",
 /*  44 */ "relational_expression ::= relational_expression QUORUM shift_expression",
 /*  45 */ "relational_expression ::= relational_expression LCP shift_expression",
 /*  46 */ "relational_expression ::= relational_expression PREFIX shift_expression",
 /*  47 */ "relational_expression ::= relational_expression SUFFIX shift_expression",
 /*  48 */ "relational_expression ::= relational_expression REGEXP shift_expression",
 /*  49 */ "shift_expression ::= shift_expression SHIFTL additive_expression",
 /*  50 */ "shift_expression ::= shift_expression SHIFTR additive_expression",
 /*  51 */ "shift_expression ::= shift_expression SHIFTRR additive_expression",
 /*  52 */ "additive_expression ::= additive_expression PLUS multiplicative_expression",
 /*  53 */ "additive_expression ::= additive_expression MINUS multiplicative_expression",
 /*  54 */ "multiplicative_expression ::= multiplicative_expression STAR unary_expression",
 /*  55 */ "multiplicative_expression ::= multiplicative_expression SLASH unary_expression",
 /*  56 */ "multiplicative_expression ::= multiplicative_expression MOD unary_expression",
 /*  57 */ "unary_expression ::= DELETE unary_expression",
 /*  58 */ "unary_expression ::= INCR unary_expression",
 /*  59 */ "unary_expression ::= DECR unary_expression",
 /*  60 */ "unary_expression ::= PLUS unary_expression",
 /*  61 */ "unary_expression ::= MINUS unary_expression",
 /*  62 */ "unary_expression ::= NOT unary_expression",
 /*  63 */ "unary_expression ::= BITWISE_NOT unary_expression",
 /*  64 */ "unary_expression ::= ADJUST unary_expression",
 /*  65 */ "unary_expression ::= EXACT unary_expression",
 /*  66 */ "unary_expression ::= PARTIAL unary_expression",
 /*  67 */ "unary_expression ::= UNSPLIT unary_expression",
 /*  68 */ "postfix_expression ::= lefthand_side_expression INCR",
 /*  69 */ "postfix_expression ::= lefthand_side_expression DECR",
 /*  70 */ "call_expression ::= member_expression arguments",
 /*  71 */ "array_literal ::= BRACKETL element_list BRACKETR",
 /*  72 */ "element_list ::=",
 /*  73 */ "element_list ::= assignment_expression",
 /*  74 */ "element_list ::= element_list COMMA assignment_expression",
 /*  75 */ "object_literal ::= BRACEL property_name_and_value_list BRACER",
 /*  76 */ "property_name_and_value_list ::=",
 /*  77 */ "property_name_and_value ::= property_name COLON assignment_expression",
 /*  78 */ "member_expression_part ::= BRACKETL expression BRACKETR",
 /*  79 */ "arguments ::= PARENL argument_list PARENR",
 /*  80 */ "argument_list ::=",
 /*  81 */ "argument_list ::= assignment_expression",
 /*  82 */ "argument_list ::= argument_list COMMA assignment_expression",
 /*  83 */ "output_columns ::=",
 /*  84 */ "output_columns ::= output_column",
 /*  85 */ "output_columns ::= output_columns COMMA",
 /*  86 */ "output_columns ::= output_columns COMMA output_column",
 /*  87 */ "output_column ::= STAR",
 /*  88 */ "output_column ::= NONEXISTENT_COLUMN",
 /*  89 */ "output_column ::= assignment_expression",
 /*  90 */ "adjuster ::= adjuster PLUS adjust_expression",
 /*  91 */ "adjust_expression ::= adjust_match_expression STAR DECIMAL",
 /*  92 */ "adjust_match_expression ::= IDENTIFIER MATCH STRING",
 /*  93 */ "sort_keys ::=",
 /*  94 */ "sort_keys ::= sort_key",
 /*  95 */ "sort_keys ::= sort_keys COMMA sort_key",
 /*  96 */ "sort_key ::= NONEXISTENT_COLUMN",
 /*  97 */ "sort_key ::= MINUS NONEXISTENT_COLUMN",
 /*  98 */ "sort_key ::= assignment_expression",
 /*  99 */ "input ::= query",
 /* 100 */ "input ::= expression",
 /* 101 */ "input ::= START_OUTPUT_COLUMNS output_columns",
 /* 102 */ "input ::= START_ADJUSTER adjuster",
 /* 103 */ "input ::= START_SORT_KEYS sort_keys",
 /* 104 */ "query ::= query_element",
 /* 105 */ "query_element ::= QSTRING",
 /* 106 */ "query_element ::= PARENL query PARENR",
 /* 107 */ "expression ::= assignment_expression",
 /* 108 */ "assignment_expression ::= conditional_expression",
 /* 109 */ "conditional_expression ::= logical_or_expression",
 /* 110 */ "logical_or_expression ::= logical_and_expression",
 /* 111 */ "logical_and_expression ::= bitwise_or_expression",
 /* 112 */ "bitwise_or_expression ::= bitwise_xor_expression",
 /* 113 */ "bitwise_xor_expression ::= bitwise_and_expression",
 /* 114 */ "bitwise_and_expression ::= equality_expression",
 /* 115 */ "equality_expression ::= relational_expression",
 /* 116 */ "relational_expression ::= shift_expression",
 /* 117 */ "shift_expression ::= additive_expression",
 /* 118 */ "additive_expression ::= multiplicative_expression",
 /* 119 */ "multiplicative_expression ::= unary_expression",
 /* 120 */ "unary_expression ::= postfix_expression",
 /* 121 */ "postfix_expression ::= lefthand_side_expression",
 /* 122 */ "lefthand_side_expression ::= call_expression",
 /* 123 */ "lefthand_side_expression ::= member_expression",
 /* 124 */ "member_expression ::= primary_expression",
 /* 125 */ "member_expression ::= member_expression member_expression_part",
 /* 126 */ "primary_expression ::= object_literal",
 /* 127 */ "primary_expression ::= PARENL expression PARENR",
 /* 128 */ "primary_expression ::= IDENTIFIER",
 /* 129 */ "primary_expression ::= array_literal",
 /* 130 */ "primary_expression ::= DECIMAL",
 /* 131 */ "primary_expression ::= HEX_INTEGER",
 /* 132 */ "primary_expression ::= STRING",
 /* 133 */ "primary_expression ::= BOOLEAN",
 /* 134 */ "primary_expression ::= NULL",
 /* 135 */ "property_name_and_value_list ::= property_name_and_value",
 /* 136 */ "property_name_and_value_list ::= property_name_and_value_list COMMA property_name_and_value",
 /* 137 */ "property_name ::= STRING",
 /* 138 */ "member_expression_part ::= DOT IDENTIFIER",
 /* 139 */ "adjuster ::=",
 /* 140 */ "adjuster ::= adjust_expression",
 /* 141 */ "adjust_expression ::= adjust_match_expression",
};
#endif /* NDEBUG */


#if YYSTACKDEPTH<=0
/*
** Try to increase the size of the parser stack.  Return the number
** of errors.  Return 0 on success.
*/
static int yyGrowStack(yyParser *p){
  int newSize;
  int idx;
  yyStackEntry *pNew;

  newSize = p->yystksz*2 + 100;
  idx = p->yytos ? (int)(p->yytos - p->yystack) : 0;
  if( p->yystack==&p->yystk0 ){
    pNew = malloc(newSize*sizeof(pNew[0]));
    if( pNew ) pNew[0] = p->yystk0;
  }else{
    pNew = realloc(p->yystack, newSize*sizeof(pNew[0]));
  }
  if( pNew ){
    p->yystack = pNew;
    p->yytos = &p->yystack[idx];
#ifndef NDEBUG
    if( yyTraceFILE ){
      fprintf(yyTraceFILE,"%sStack grows from %d to %d entries.\n",
              yyTracePrompt, p->yystksz, newSize);
    }
#endif
    p->yystksz = newSize;
  }
  return pNew==0; 
}
#endif

/* Datatype of the argument to the memory allocated passed as the
** second argument to grn_expr_parserAlloc() below.  This can be changed by
** putting an appropriate #define in the %include section of the input
** grammar.
*/
#ifndef YYMALLOCARGTYPE
# define YYMALLOCARGTYPE size_t
#endif

/* Initialize a new parser that has already been allocated.
*/
void grn_expr_parserInit(void *yypRawParser grn_expr_parserCTX_PDECL){
  yyParser *yypParser = (yyParser*)yypRawParser;
  grn_expr_parserCTX_STORE
#ifdef YYTRACKMAXSTACKDEPTH
  yypParser->yyhwm = 0;
#endif
#if YYSTACKDEPTH<=0
  yypParser->yytos = NULL;
  yypParser->yystack = NULL;
  yypParser->yystksz = 0;
  if( yyGrowStack(yypParser) ){
    yypParser->yystack = &yypParser->yystk0;
    yypParser->yystksz = 1;
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  yypParser->yytos = yypParser->yystack;
  yypParser->yystack[0].stateno = 0;
  yypParser->yystack[0].major = 0;
#if YYSTACKDEPTH>0
  yypParser->yystackEnd = &yypParser->yystack[YYSTACKDEPTH-1];
#endif
}

#ifndef grn_expr_parser_ENGINEALWAYSONSTACK
/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to grn_expr_parser and grn_expr_parserFree.
*/
void *grn_expr_parserAlloc(void *(*mallocProc)(YYMALLOCARGTYPE) grn_expr_parserCTX_PDECL){
  yyParser *yypParser;
  yypParser = (yyParser*)(*mallocProc)( (YYMALLOCARGTYPE)sizeof(yyParser) );
  if( yypParser ){
    grn_expr_parserCTX_STORE
    grn_expr_parserInit(yypParser grn_expr_parserCTX_PARAM);
  }
  return (void*)yypParser;
}
#endif /* grn_expr_parser_ENGINEALWAYSONSTACK */


/* The following function deletes the "minor type" or semantic value
** associated with a symbol.  The symbol can be either a terminal
** or nonterminal. "yymajor" is the symbol code, and "yypminor" is
** a pointer to the value to be deleted.  The code used to do the 
** deletions is derived from the %destructor and/or %token_destructor
** directives of the input grammar.
*/
static void yy_destructor(
  yyParser *yypParser,    /* The parser */
  YYCODETYPE yymajor,     /* Type code for object to destroy */
  YYMINORTYPE *yypminor   /* The object to be destroyed */
){
  grn_expr_parserARG_FETCH
  grn_expr_parserCTX_FETCH
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are *not* used
    ** inside the C code.
    */
/********* Begin destructor definitions ***************************************/
    case 79: /* suppress_unused_variable_warning */
{
#line 56 "../../groonga/lib/grn_ecmascript.lemon"

  (void)efsi;

#line 1262 "../../groonga/lib/grn_ecmascript.c"
}
      break;
/********* End destructor definitions *****************************************/
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
*/
static void yy_pop_parser_stack(yyParser *pParser){
  yyStackEntry *yytos;
  assert( pParser->yytos!=0 );
  assert( pParser->yytos > pParser->yystack );
  yytos = pParser->yytos--;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yy_destructor(pParser, yytos->major, &yytos->minor);
}

/*
** Clear all secondary memory allocations from the parser
*/
void grn_expr_parserFinalize(void *p){
  yyParser *pParser = (yyParser*)p;
  while( pParser->yytos>pParser->yystack ) yy_pop_parser_stack(pParser);
#if YYSTACKDEPTH<=0
  if( pParser->yystack!=&pParser->yystk0 ) free(pParser->yystack);
#endif
}

#ifndef grn_expr_parser_ENGINEALWAYSONSTACK
/* 
** Deallocate and destroy a parser.  Destructors are called for
** all stack elements before shutting the parser down.
**
** If the YYPARSEFREENEVERNULL macro exists (for example because it
** is defined in a %include section of the input grammar) then it is
** assumed that the input pointer is never NULL.
*/
void grn_expr_parserFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
#ifndef YYPARSEFREENEVERNULL
  if( p==0 ) return;
#endif
  grn_expr_parserFinalize(p);
  (*freeProc)(p);
}
#endif /* grn_expr_parser_ENGINEALWAYSONSTACK */

/*
** Return the peak depth of the stack for a parser.
*/
#ifdef YYTRACKMAXSTACKDEPTH
int grn_expr_parserStackPeak(void *p){
  yyParser *pParser = (yyParser*)p;
  return pParser->yyhwm;
}
#endif

/* This array of booleans keeps track of the parser statement
** coverage.  The element yycoverage[X][Y] is set when the parser
** is in state X and has a lookahead token Y.  In a well-tested
** systems, every element of this matrix should end up being set.
*/
#if defined(YYCOVERAGE)
static unsigned char yycoverage[YYNSTATE][YYNTOKEN];
#endif

/*
** Write into out a description of every state/lookahead combination that
**
**   (1)  has not been used by the parser, and
**   (2)  is not a syntax error.
**
** Return the number of missed state/lookahead combinations.
*/
#if defined(YYCOVERAGE)
int grn_expr_parserCoverage(FILE *out){
  int stateno, iLookAhead, i;
  int nMissed = 0;
  for(stateno=0; stateno<YYNSTATE; stateno++){
    i = yy_shift_ofst[stateno];
    for(iLookAhead=0; iLookAhead<YYNTOKEN; iLookAhead++){
      if( yy_lookahead[i+iLookAhead]!=iLookAhead ) continue;
      if( yycoverage[stateno][iLookAhead]==0 ) nMissed++;
      if( out ){
        fprintf(out,"State %d lookahead %s %s\n", stateno,
                yyTokenName[iLookAhead],
                yycoverage[stateno][iLookAhead] ? "ok" : "missed");
      }
    }
  }
  return nMissed;
}
#endif

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_shift_action(
  YYCODETYPE iLookAhead,    /* The look-ahead token */
  YYACTIONTYPE stateno      /* Current state number */
){
  int i;

  if( stateno>YY_MAX_SHIFT ) return stateno;
  assert( stateno <= YY_SHIFT_COUNT );
#if defined(YYCOVERAGE)
  yycoverage[stateno][iLookAhead] = 1;
#endif
  do{
    i = yy_shift_ofst[stateno];
    assert( i>=0 );
    assert( i<=YY_ACTTAB_COUNT );
    assert( i+YYNTOKEN<=(int)YY_NLOOKAHEAD );
    assert( iLookAhead!=YYNOCODE );
    assert( iLookAhead < YYNTOKEN );
    i += iLookAhead;
    assert( i<(int)YY_NLOOKAHEAD );
    if( yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
      YYCODETYPE iFallback;            /* Fallback token */
      assert( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0]) );
      iFallback = yyFallback[iLookAhead];
      if( iFallback!=0 ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
             yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
        }
#endif
        assert( yyFallback[iFallback]==0 ); /* Fallback loop must terminate */
        iLookAhead = iFallback;
        continue;
      }
#endif
#ifdef YYWILDCARD
      {
        int j = i - iLookAhead + YYWILDCARD;
        assert( j<(int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])) );
        if( yy_lookahead[j]==YYWILDCARD && iLookAhead>0 ){
#ifndef NDEBUG
          if( yyTraceFILE ){
            fprintf(yyTraceFILE, "%sWILDCARD %s => %s\n",
               yyTracePrompt, yyTokenName[iLookAhead],
               yyTokenName[YYWILDCARD]);
          }
#endif /* NDEBUG */
          return yy_action[j];
        }
      }
#endif /* YYWILDCARD */
      return yy_default[stateno];
    }else{
      assert( i>=0 && i<(int)(sizeof(yy_action)/sizeof(yy_action[0])) );
      return yy_action[i];
    }
  }while(1);
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_reduce_action(
  YYACTIONTYPE stateno,     /* Current state number */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
#ifdef YYERRORSYMBOL
  if( stateno>YY_REDUCE_COUNT ){
    return yy_default[stateno];
  }
#else
  assert( stateno<=YY_REDUCE_COUNT );
#endif
  i = yy_reduce_ofst[stateno];
  assert( iLookAhead!=YYNOCODE );
  i += iLookAhead;
#ifdef YYERRORSYMBOL
  if( i<0 || i>=YY_ACTTAB_COUNT || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }
#else
  assert( i>=0 && i<YY_ACTTAB_COUNT );
  assert( yy_lookahead[i]==iLookAhead );
#endif
  return yy_action[i];
}

/*
** The following routine is called if the stack overflows.
*/
static void yyStackOverflow(yyParser *yypParser){
   grn_expr_parserARG_FETCH
   grn_expr_parserCTX_FETCH
#ifndef NDEBUG
   if( yyTraceFILE ){
     fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
   }
#endif
   while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
   /* Here code is inserted which will execute if the parser
   ** stack every overflows */
/******** Begin %stack_overflow code ******************************************/
/******** End %stack_overflow code ********************************************/
   grn_expr_parserARG_STORE /* Suppress warning about unused %extra_argument var */
   grn_expr_parserCTX_STORE
}

/*
** Print tracing information for a SHIFT action
*/
#ifndef NDEBUG
static void yyTraceShift(yyParser *yypParser, int yyNewState, const char *zTag){
  if( yyTraceFILE ){
    if( yyNewState<YYNSTATE ){
      fprintf(yyTraceFILE,"%s%s '%s', go to state %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState);
    }else{
      fprintf(yyTraceFILE,"%s%s '%s', pending reduce %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState - YY_MIN_REDUCE);
    }
  }
}
#else
# define yyTraceShift(X,Y,Z)
#endif

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  YYACTIONTYPE yyNewState,      /* The new state to shift in */
  YYCODETYPE yyMajor,           /* The major token to shift in */
  grn_expr_parserTOKENTYPE yyMinor        /* The minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yytos++;
#ifdef YYTRACKMAXSTACKDEPTH
  if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
    yypParser->yyhwm++;
    assert( yypParser->yyhwm == (int)(yypParser->yytos - yypParser->yystack) );
  }
#endif
#if YYSTACKDEPTH>0 
  if( yypParser->yytos>yypParser->yystackEnd ){
    yypParser->yytos--;
    yyStackOverflow(yypParser);
    return;
  }
#else
  if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz] ){
    if( yyGrowStack(yypParser) ){
      yypParser->yytos--;
      yyStackOverflow(yypParser);
      return;
    }
  }
#endif
  if( yyNewState > YY_MAX_SHIFT ){
    yyNewState += YY_MIN_REDUCE - YY_MIN_SHIFTREDUCE;
  }
  yytos = yypParser->yytos;
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor.yy0 = yyMinor;
  yyTraceShift(yypParser, yyNewState, "Shift");
}

/* For rule J, yyRuleInfoLhs[J] contains the symbol on the left-hand side
** of that rule */
static const YYCODETYPE yyRuleInfoLhs[] = {
    81,  /* (0) query ::= query query_element */
    81,  /* (1) query ::= query LOGICAL_AND query_element */
    81,  /* (2) query ::= query LOGICAL_AND_NOT query_element */
    81,  /* (3) query ::= query LOGICAL_OR query_element */
    81,  /* (4) query ::= query NEGATIVE query_element */
    86,  /* (5) query_element ::= ADJUST query_element */
    86,  /* (6) query_element ::= RELATIVE_OP query_element */
    86,  /* (7) query_element ::= IDENTIFIER RELATIVE_OP query_element */
    86,  /* (8) query_element ::= BRACEL expression BRACER */
    86,  /* (9) query_element ::= EVAL primary_expression */
    82,  /* (10) expression ::= expression COMMA assignment_expression */
    88,  /* (11) assignment_expression ::= lefthand_side_expression ASSIGN assignment_expression */
    88,  /* (12) assignment_expression ::= lefthand_side_expression STAR_ASSIGN assignment_expression */
    88,  /* (13) assignment_expression ::= lefthand_side_expression SLASH_ASSIGN assignment_expression */
    88,  /* (14) assignment_expression ::= lefthand_side_expression MOD_ASSIGN assignment_expression */
    88,  /* (15) assignment_expression ::= lefthand_side_expression PLUS_ASSIGN assignment_expression */
    88,  /* (16) assignment_expression ::= lefthand_side_expression MINUS_ASSIGN assignment_expression */
    88,  /* (17) assignment_expression ::= lefthand_side_expression SHIFTL_ASSIGN assignment_expression */
    88,  /* (18) assignment_expression ::= lefthand_side_expression SHIFTR_ASSIGN assignment_expression */
    88,  /* (19) assignment_expression ::= lefthand_side_expression SHIFTRR_ASSIGN assignment_expression */
    88,  /* (20) assignment_expression ::= lefthand_side_expression AND_ASSIGN assignment_expression */
    88,  /* (21) assignment_expression ::= lefthand_side_expression XOR_ASSIGN assignment_expression */
    88,  /* (22) assignment_expression ::= lefthand_side_expression OR_ASSIGN assignment_expression */
    89,  /* (23) conditional_expression ::= logical_or_expression QUESTION assignment_expression COLON assignment_expression */
    91,  /* (24) logical_or_expression ::= logical_or_expression LOGICAL_OR logical_and_expression */
    92,  /* (25) logical_and_expression ::= logical_and_expression LOGICAL_AND bitwise_or_expression */
    92,  /* (26) logical_and_expression ::= logical_and_expression LOGICAL_AND_NOT bitwise_or_expression */
    93,  /* (27) bitwise_or_expression ::= bitwise_or_expression BITWISE_OR bitwise_xor_expression */
    94,  /* (28) bitwise_xor_expression ::= bitwise_xor_expression BITWISE_XOR bitwise_and_expression */
    95,  /* (29) bitwise_and_expression ::= bitwise_and_expression BITWISE_AND equality_expression */
    96,  /* (30) equality_expression ::= equality_expression EQUAL relational_expression */
    96,  /* (31) equality_expression ::= equality_expression NOT_EQUAL relational_expression */
    97,  /* (32) relational_expression ::= relational_expression LESS shift_expression */
    97,  /* (33) relational_expression ::= relational_expression GREATER shift_expression */
    97,  /* (34) relational_expression ::= relational_expression LESS_EQUAL shift_expression */
    97,  /* (35) relational_expression ::= relational_expression GREATER_EQUAL shift_expression */
    97,  /* (36) relational_expression ::= relational_expression IN shift_expression */
    97,  /* (37) relational_expression ::= relational_expression MATCH shift_expression */
    97,  /* (38) relational_expression ::= relational_expression NEAR shift_expression */
    97,  /* (39) relational_expression ::= relational_expression NEAR2 shift_expression */
    97,  /* (40) relational_expression ::= relational_expression NEAR_PHRASE shift_expression */
    97,  /* (41) relational_expression ::= relational_expression ORDERED_NEAR_PHRASE shift_expression */
    97,  /* (42) relational_expression ::= relational_expression SIMILAR shift_expression */
    97,  /* (43) relational_expression ::= relational_expression TERM_EXTRACT shift_expression */
    97,  /* (44) relational_expression ::= relational_expression QUORUM shift_expression */
    97,  /* (45) relational_expression ::= relational_expression LCP shift_expression */
    97,  /* (46) relational_expression ::= relational_expression PREFIX shift_expression */
    97,  /* (47) relational_expression ::= relational_expression SUFFIX shift_expression */
    97,  /* (48) relational_expression ::= relational_expression REGEXP shift_expression */
    98,  /* (49) shift_expression ::= shift_expression SHIFTL additive_expression */
    98,  /* (50) shift_expression ::= shift_expression SHIFTR additive_expression */
    98,  /* (51) shift_expression ::= shift_expression SHIFTRR additive_expression */
    99,  /* (52) additive_expression ::= additive_expression PLUS multiplicative_expression */
    99,  /* (53) additive_expression ::= additive_expression MINUS multiplicative_expression */
   100,  /* (54) multiplicative_expression ::= multiplicative_expression STAR unary_expression */
   100,  /* (55) multiplicative_expression ::= multiplicative_expression SLASH unary_expression */
   100,  /* (56) multiplicative_expression ::= multiplicative_expression MOD unary_expression */
   101,  /* (57) unary_expression ::= DELETE unary_expression */
   101,  /* (58) unary_expression ::= INCR unary_expression */
   101,  /* (59) unary_expression ::= DECR unary_expression */
   101,  /* (60) unary_expression ::= PLUS unary_expression */
   101,  /* (61) unary_expression ::= MINUS unary_expression */
   101,  /* (62) unary_expression ::= NOT unary_expression */
   101,  /* (63) unary_expression ::= BITWISE_NOT unary_expression */
   101,  /* (64) unary_expression ::= ADJUST unary_expression */
   101,  /* (65) unary_expression ::= EXACT unary_expression */
   101,  /* (66) unary_expression ::= PARTIAL unary_expression */
   101,  /* (67) unary_expression ::= UNSPLIT unary_expression */
   102,  /* (68) postfix_expression ::= lefthand_side_expression INCR */
   102,  /* (69) postfix_expression ::= lefthand_side_expression DECR */
   103,  /* (70) call_expression ::= member_expression arguments */
   108,  /* (71) array_literal ::= BRACKETL element_list BRACKETR */
   109,  /* (72) element_list ::= */
   109,  /* (73) element_list ::= assignment_expression */
   109,  /* (74) element_list ::= element_list COMMA assignment_expression */
   107,  /* (75) object_literal ::= BRACEL property_name_and_value_list BRACER */
   110,  /* (76) property_name_and_value_list ::= */
   111,  /* (77) property_name_and_value ::= property_name COLON assignment_expression */
   106,  /* (78) member_expression_part ::= BRACKETL expression BRACKETR */
   105,  /* (79) arguments ::= PARENL argument_list PARENR */
   113,  /* (80) argument_list ::= */
   113,  /* (81) argument_list ::= assignment_expression */
   113,  /* (82) argument_list ::= argument_list COMMA assignment_expression */
    83,  /* (83) output_columns ::= */
    83,  /* (84) output_columns ::= output_column */
    83,  /* (85) output_columns ::= output_columns COMMA */
    83,  /* (86) output_columns ::= output_columns COMMA output_column */
   114,  /* (87) output_column ::= STAR */
   114,  /* (88) output_column ::= NONEXISTENT_COLUMN */
   114,  /* (89) output_column ::= assignment_expression */
    84,  /* (90) adjuster ::= adjuster PLUS adjust_expression */
   115,  /* (91) adjust_expression ::= adjust_match_expression STAR DECIMAL */
   116,  /* (92) adjust_match_expression ::= IDENTIFIER MATCH STRING */
    85,  /* (93) sort_keys ::= */
    85,  /* (94) sort_keys ::= sort_key */
    85,  /* (95) sort_keys ::= sort_keys COMMA sort_key */
   117,  /* (96) sort_key ::= NONEXISTENT_COLUMN */
   117,  /* (97) sort_key ::= MINUS NONEXISTENT_COLUMN */
   117,  /* (98) sort_key ::= assignment_expression */
    80,  /* (99) input ::= query */
    80,  /* (100) input ::= expression */
    80,  /* (101) input ::= START_OUTPUT_COLUMNS output_columns */
    80,  /* (102) input ::= START_ADJUSTER adjuster */
    80,  /* (103) input ::= START_SORT_KEYS sort_keys */
    81,  /* (104) query ::= query_element */
    86,  /* (105) query_element ::= QSTRING */
    86,  /* (106) query_element ::= PARENL query PARENR */
    82,  /* (107) expression ::= assignment_expression */
    88,  /* (108) assignment_expression ::= conditional_expression */
    89,  /* (109) conditional_expression ::= logical_or_expression */
    91,  /* (110) logical_or_expression ::= logical_and_expression */
    92,  /* (111) logical_and_expression ::= bitwise_or_expression */
    93,  /* (112) bitwise_or_expression ::= bitwise_xor_expression */
    94,  /* (113) bitwise_xor_expression ::= bitwise_and_expression */
    95,  /* (114) bitwise_and_expression ::= equality_expression */
    96,  /* (115) equality_expression ::= relational_expression */
    97,  /* (116) relational_expression ::= shift_expression */
    98,  /* (117) shift_expression ::= additive_expression */
    99,  /* (118) additive_expression ::= multiplicative_expression */
   100,  /* (119) multiplicative_expression ::= unary_expression */
   101,  /* (120) unary_expression ::= postfix_expression */
   102,  /* (121) postfix_expression ::= lefthand_side_expression */
    90,  /* (122) lefthand_side_expression ::= call_expression */
    90,  /* (123) lefthand_side_expression ::= member_expression */
   104,  /* (124) member_expression ::= primary_expression */
   104,  /* (125) member_expression ::= member_expression member_expression_part */
    87,  /* (126) primary_expression ::= object_literal */
    87,  /* (127) primary_expression ::= PARENL expression PARENR */
    87,  /* (128) primary_expression ::= IDENTIFIER */
    87,  /* (129) primary_expression ::= array_literal */
    87,  /* (130) primary_expression ::= DECIMAL */
    87,  /* (131) primary_expression ::= HEX_INTEGER */
    87,  /* (132) primary_expression ::= STRING */
    87,  /* (133) primary_expression ::= BOOLEAN */
    87,  /* (134) primary_expression ::= NULL */
   110,  /* (135) property_name_and_value_list ::= property_name_and_value */
   110,  /* (136) property_name_and_value_list ::= property_name_and_value_list COMMA property_name_and_value */
   112,  /* (137) property_name ::= STRING */
   106,  /* (138) member_expression_part ::= DOT IDENTIFIER */
    84,  /* (139) adjuster ::= */
    84,  /* (140) adjuster ::= adjust_expression */
   115,  /* (141) adjust_expression ::= adjust_match_expression */
};

/* For rule J, yyRuleInfoNRhs[J] contains the negative of the number
** of symbols on the right-hand side of that rule. */
static const signed char yyRuleInfoNRhs[] = {
   -2,  /* (0) query ::= query query_element */
   -3,  /* (1) query ::= query LOGICAL_AND query_element */
   -3,  /* (2) query ::= query LOGICAL_AND_NOT query_element */
   -3,  /* (3) query ::= query LOGICAL_OR query_element */
   -3,  /* (4) query ::= query NEGATIVE query_element */
   -2,  /* (5) query_element ::= ADJUST query_element */
   -2,  /* (6) query_element ::= RELATIVE_OP query_element */
   -3,  /* (7) query_element ::= IDENTIFIER RELATIVE_OP query_element */
   -3,  /* (8) query_element ::= BRACEL expression BRACER */
   -2,  /* (9) query_element ::= EVAL primary_expression */
   -3,  /* (10) expression ::= expression COMMA assignment_expression */
   -3,  /* (11) assignment_expression ::= lefthand_side_expression ASSIGN assignment_expression */
   -3,  /* (12) assignment_expression ::= lefthand_side_expression STAR_ASSIGN assignment_expression */
   -3,  /* (13) assignment_expression ::= lefthand_side_expression SLASH_ASSIGN assignment_expression */
   -3,  /* (14) assignment_expression ::= lefthand_side_expression MOD_ASSIGN assignment_expression */
   -3,  /* (15) assignment_expression ::= lefthand_side_expression PLUS_ASSIGN assignment_expression */
   -3,  /* (16) assignment_expression ::= lefthand_side_expression MINUS_ASSIGN assignment_expression */
   -3,  /* (17) assignment_expression ::= lefthand_side_expression SHIFTL_ASSIGN assignment_expression */
   -3,  /* (18) assignment_expression ::= lefthand_side_expression SHIFTR_ASSIGN assignment_expression */
   -3,  /* (19) assignment_expression ::= lefthand_side_expression SHIFTRR_ASSIGN assignment_expression */
   -3,  /* (20) assignment_expression ::= lefthand_side_expression AND_ASSIGN assignment_expression */
   -3,  /* (21) assignment_expression ::= lefthand_side_expression XOR_ASSIGN assignment_expression */
   -3,  /* (22) assignment_expression ::= lefthand_side_expression OR_ASSIGN assignment_expression */
   -5,  /* (23) conditional_expression ::= logical_or_expression QUESTION assignment_expression COLON assignment_expression */
   -3,  /* (24) logical_or_expression ::= logical_or_expression LOGICAL_OR logical_and_expression */
   -3,  /* (25) logical_and_expression ::= logical_and_expression LOGICAL_AND bitwise_or_expression */
   -3,  /* (26) logical_and_expression ::= logical_and_expression LOGICAL_AND_NOT bitwise_or_expression */
   -3,  /* (27) bitwise_or_expression ::= bitwise_or_expression BITWISE_OR bitwise_xor_expression */
   -3,  /* (28) bitwise_xor_expression ::= bitwise_xor_expression BITWISE_XOR bitwise_and_expression */
   -3,  /* (29) bitwise_and_expression ::= bitwise_and_expression BITWISE_AND equality_expression */
   -3,  /* (30) equality_expression ::= equality_expression EQUAL relational_expression */
   -3,  /* (31) equality_expression ::= equality_expression NOT_EQUAL relational_expression */
   -3,  /* (32) relational_expression ::= relational_expression LESS shift_expression */
   -3,  /* (33) relational_expression ::= relational_expression GREATER shift_expression */
   -3,  /* (34) relational_expression ::= relational_expression LESS_EQUAL shift_expression */
   -3,  /* (35) relational_expression ::= relational_expression GREATER_EQUAL shift_expression */
   -3,  /* (36) relational_expression ::= relational_expression IN shift_expression */
   -3,  /* (37) relational_expression ::= relational_expression MATCH shift_expression */
   -3,  /* (38) relational_expression ::= relational_expression NEAR shift_expression */
   -3,  /* (39) relational_expression ::= relational_expression NEAR2 shift_expression */
   -3,  /* (40) relational_expression ::= relational_expression NEAR_PHRASE shift_expression */
   -3,  /* (41) relational_expression ::= relational_expression ORDERED_NEAR_PHRASE shift_expression */
   -3,  /* (42) relational_expression ::= relational_expression SIMILAR shift_expression */
   -3,  /* (43) relational_expression ::= relational_expression TERM_EXTRACT shift_expression */
   -3,  /* (44) relational_expression ::= relational_expression QUORUM shift_expression */
   -3,  /* (45) relational_expression ::= relational_expression LCP shift_expression */
   -3,  /* (46) relational_expression ::= relational_expression PREFIX shift_expression */
   -3,  /* (47) relational_expression ::= relational_expression SUFFIX shift_expression */
   -3,  /* (48) relational_expression ::= relational_expression REGEXP shift_expression */
   -3,  /* (49) shift_expression ::= shift_expression SHIFTL additive_expression */
   -3,  /* (50) shift_expression ::= shift_expression SHIFTR additive_expression */
   -3,  /* (51) shift_expression ::= shift_expression SHIFTRR additive_expression */
   -3,  /* (52) additive_expression ::= additive_expression PLUS multiplicative_expression */
   -3,  /* (53) additive_expression ::= additive_expression MINUS multiplicative_expression */
   -3,  /* (54) multiplicative_expression ::= multiplicative_expression STAR unary_expression */
   -3,  /* (55) multiplicative_expression ::= multiplicative_expression SLASH unary_expression */
   -3,  /* (56) multiplicative_expression ::= multiplicative_expression MOD unary_expression */
   -2,  /* (57) unary_expression ::= DELETE unary_expression */
   -2,  /* (58) unary_expression ::= INCR unary_expression */
   -2,  /* (59) unary_expression ::= DECR unary_expression */
   -2,  /* (60) unary_expression ::= PLUS unary_expression */
   -2,  /* (61) unary_expression ::= MINUS unary_expression */
   -2,  /* (62) unary_expression ::= NOT unary_expression */
   -2,  /* (63) unary_expression ::= BITWISE_NOT unary_expression */
   -2,  /* (64) unary_expression ::= ADJUST unary_expression */
   -2,  /* (65) unary_expression ::= EXACT unary_expression */
   -2,  /* (66) unary_expression ::= PARTIAL unary_expression */
   -2,  /* (67) unary_expression ::= UNSPLIT unary_expression */
   -2,  /* (68) postfix_expression ::= lefthand_side_expression INCR */
   -2,  /* (69) postfix_expression ::= lefthand_side_expression DECR */
   -2,  /* (70) call_expression ::= member_expression arguments */
   -3,  /* (71) array_literal ::= BRACKETL element_list BRACKETR */
    0,  /* (72) element_list ::= */
   -1,  /* (73) element_list ::= assignment_expression */
   -3,  /* (74) element_list ::= element_list COMMA assignment_expression */
   -3,  /* (75) object_literal ::= BRACEL property_name_and_value_list BRACER */
    0,  /* (76) property_name_and_value_list ::= */
   -3,  /* (77) property_name_and_value ::= property_name COLON assignment_expression */
   -3,  /* (78) member_expression_part ::= BRACKETL expression BRACKETR */
   -3,  /* (79) arguments ::= PARENL argument_list PARENR */
    0,  /* (80) argument_list ::= */
   -1,  /* (81) argument_list ::= assignment_expression */
   -3,  /* (82) argument_list ::= argument_list COMMA assignment_expression */
    0,  /* (83) output_columns ::= */
   -1,  /* (84) output_columns ::= output_column */
   -2,  /* (85) output_columns ::= output_columns COMMA */
   -3,  /* (86) output_columns ::= output_columns COMMA output_column */
   -1,  /* (87) output_column ::= STAR */
   -1,  /* (88) output_column ::= NONEXISTENT_COLUMN */
   -1,  /* (89) output_column ::= assignment_expression */
   -3,  /* (90) adjuster ::= adjuster PLUS adjust_expression */
   -3,  /* (91) adjust_expression ::= adjust_match_expression STAR DECIMAL */
   -3,  /* (92) adjust_match_expression ::= IDENTIFIER MATCH STRING */
    0,  /* (93) sort_keys ::= */
   -1,  /* (94) sort_keys ::= sort_key */
   -3,  /* (95) sort_keys ::= sort_keys COMMA sort_key */
   -1,  /* (96) sort_key ::= NONEXISTENT_COLUMN */
   -2,  /* (97) sort_key ::= MINUS NONEXISTENT_COLUMN */
   -1,  /* (98) sort_key ::= assignment_expression */
   -1,  /* (99) input ::= query */
   -1,  /* (100) input ::= expression */
   -2,  /* (101) input ::= START_OUTPUT_COLUMNS output_columns */
   -2,  /* (102) input ::= START_ADJUSTER adjuster */
   -2,  /* (103) input ::= START_SORT_KEYS sort_keys */
   -1,  /* (104) query ::= query_element */
   -1,  /* (105) query_element ::= QSTRING */
   -3,  /* (106) query_element ::= PARENL query PARENR */
   -1,  /* (107) expression ::= assignment_expression */
   -1,  /* (108) assignment_expression ::= conditional_expression */
   -1,  /* (109) conditional_expression ::= logical_or_expression */
   -1,  /* (110) logical_or_expression ::= logical_and_expression */
   -1,  /* (111) logical_and_expression ::= bitwise_or_expression */
   -1,  /* (112) bitwise_or_expression ::= bitwise_xor_expression */
   -1,  /* (113) bitwise_xor_expression ::= bitwise_and_expression */
   -1,  /* (114) bitwise_and_expression ::= equality_expression */
   -1,  /* (115) equality_expression ::= relational_expression */
   -1,  /* (116) relational_expression ::= shift_expression */
   -1,  /* (117) shift_expression ::= additive_expression */
   -1,  /* (118) additive_expression ::= multiplicative_expression */
   -1,  /* (119) multiplicative_expression ::= unary_expression */
   -1,  /* (120) unary_expression ::= postfix_expression */
   -1,  /* (121) postfix_expression ::= lefthand_side_expression */
   -1,  /* (122) lefthand_side_expression ::= call_expression */
   -1,  /* (123) lefthand_side_expression ::= member_expression */
   -1,  /* (124) member_expression ::= primary_expression */
   -2,  /* (125) member_expression ::= member_expression member_expression_part */
   -1,  /* (126) primary_expression ::= object_literal */
   -3,  /* (127) primary_expression ::= PARENL expression PARENR */
   -1,  /* (128) primary_expression ::= IDENTIFIER */
   -1,  /* (129) primary_expression ::= array_literal */
   -1,  /* (130) primary_expression ::= DECIMAL */
   -1,  /* (131) primary_expression ::= HEX_INTEGER */
   -1,  /* (132) primary_expression ::= STRING */
   -1,  /* (133) primary_expression ::= BOOLEAN */
   -1,  /* (134) primary_expression ::= NULL */
   -1,  /* (135) property_name_and_value_list ::= property_name_and_value */
   -3,  /* (136) property_name_and_value_list ::= property_name_and_value_list COMMA property_name_and_value */
   -1,  /* (137) property_name ::= STRING */
   -2,  /* (138) member_expression_part ::= DOT IDENTIFIER */
    0,  /* (139) adjuster ::= */
   -1,  /* (140) adjuster ::= adjust_expression */
   -1,  /* (141) adjust_expression ::= adjust_match_expression */
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
**
** The yyLookahead and yyLookaheadToken parameters provide reduce actions
** access to the lookahead token (if any).  The yyLookahead will be YYNOCODE
** if the lookahead token has already been consumed.  As this procedure is
** only called from one place, optimizing compilers will in-line it, which
** means that the extra parameters have no performance impact.
*/
static YYACTIONTYPE yy_reduce(
  yyParser *yypParser,         /* The parser */
  unsigned int yyruleno,       /* Number of the rule by which to reduce */
  int yyLookahead,             /* Lookahead token, or YYNOCODE if none */
  grn_expr_parserTOKENTYPE yyLookaheadToken  /* Value of the lookahead token */
  grn_expr_parserCTX_PDECL                   /* %extra_context */
){
  int yygoto;                     /* The next state */
  YYACTIONTYPE yyact;             /* The next action */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  grn_expr_parserARG_FETCH
  (void)yyLookahead;
  (void)yyLookaheadToken;
  yymsp = yypParser->yytos;
  assert( yyruleno<(int)(sizeof(yyRuleName)/sizeof(yyRuleName[0])) );
#ifndef NDEBUG
  if( yyTraceFILE ){
    yysize = yyRuleInfoNRhs[yyruleno];
    if( yysize ){
      fprintf(yyTraceFILE, "%sReduce %d [%s]%s, pop back to state %d.\n",
        yyTracePrompt,
        yyruleno, yyRuleName[yyruleno],
        yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action",
        yymsp[yysize].stateno);
    }else{
      fprintf(yyTraceFILE, "%sReduce %d [%s]%s.\n",
        yyTracePrompt, yyruleno, yyRuleName[yyruleno],
        yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action");
    }
  }
#endif /* NDEBUG */

  /* Check that the stack is large enough to grow by a single entry
  ** if the RHS of the rule is empty.  This ensures that there is room
  ** enough on the stack to push the LHS value */
  if( yyRuleInfoNRhs[yyruleno]==0 ){
#ifdef YYTRACKMAXSTACKDEPTH
    if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
      yypParser->yyhwm++;
      assert( yypParser->yyhwm == (int)(yypParser->yytos - yypParser->yystack));
    }
#endif
#if YYSTACKDEPTH>0 
    if( yypParser->yytos>=yypParser->yystackEnd ){
      yyStackOverflow(yypParser);
      /* The call to yyStackOverflow() above pops the stack until it is
      ** empty, causing the main parser loop to exit.  So the return value
      ** is never used and does not matter. */
      return 0;
    }
#else
    if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz-1] ){
      if( yyGrowStack(yypParser) ){
        yyStackOverflow(yypParser);
        /* The call to yyStackOverflow() above pops the stack until it is
        ** empty, causing the main parser loop to exit.  So the return value
        ** is never used and does not matter. */
        return 0;
      }
      yymsp = yypParser->yytos;
    }
#endif
  }

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
/********** Begin reduce actions **********************************************/
        YYMINORTYPE yylhsminor;
      case 0: /* query ::= query query_element */
#line 98 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, grn_int32_value_at(&efsi->op_stack, -1), 2);
}
#line 1935 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 1: /* query ::= query LOGICAL_AND query_element */
      case 25: /* logical_and_expression ::= logical_and_expression LOGICAL_AND bitwise_or_expression */ yytestcase(yyruleno==25);
#line 101 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_AND, 2);
}
#line 1943 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 2: /* query ::= query LOGICAL_AND_NOT query_element */
      case 26: /* logical_and_expression ::= logical_and_expression LOGICAL_AND_NOT bitwise_or_expression */ yytestcase(yyruleno==26);
#line 104 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_AND_NOT, 2);
}
#line 1951 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 3: /* query ::= query LOGICAL_OR query_element */
      case 24: /* logical_or_expression ::= logical_or_expression LOGICAL_OR logical_and_expression */ yytestcase(yyruleno==24);
#line 107 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_OR, 2);
}
#line 1959 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 4: /* query ::= query NEGATIVE query_element */
#line 110 "../../groonga/lib/grn_ecmascript.lemon"
{
  float weight;
  GRN_FLOAT32_POP(&efsi->weight_stack, weight);
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_ADJUST, 2);
}
#line 1968 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 5: /* query_element ::= ADJUST query_element */
#line 119 "../../groonga/lib/grn_ecmascript.lemon"
{
  float weight;
  GRN_FLOAT32_POP(&efsi->weight_stack, weight);
}
#line 1976 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 6: /* query_element ::= RELATIVE_OP query_element */
#line 123 "../../groonga/lib/grn_ecmascript.lemon"
{
  int mode;
  GRN_INT32_POP(&efsi->mode_stack, mode);
}
#line 1984 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 7: /* query_element ::= IDENTIFIER RELATIVE_OP query_element */
#line 127 "../../groonga/lib/grn_ecmascript.lemon"
{
  int mode;
  grn_obj *c;
  GRN_PTR_POP(&efsi->column_stack, c);
  GRN_INT32_POP(&efsi->mode_stack, mode);
  switch (mode) {
  case GRN_OP_NEAR :
  case GRN_OP_NEAR2 :
    {
      int max_interval;
      GRN_INT32_POP(&efsi->max_interval_stack, max_interval);
    }
    break;
  case GRN_OP_NEAR_PHRASE :
  case GRN_OP_ORDERED_NEAR_PHRASE :
    {
      int max_interval;
      GRN_INT32_POP(&efsi->max_interval_stack, max_interval);
      int additional_last_interval;
      GRN_INT32_POP(&efsi->additional_last_interval_stack,
                    additional_last_interval);
    }
    break;
  case GRN_OP_SIMILAR :
    {
      int similarity_threshold;
      GRN_INT32_POP(&efsi->similarity_threshold_stack, similarity_threshold);
    }
    break;
  case GRN_OP_QUORUM :
    {
      int quorum_threshold;
      GRN_INT32_POP(&efsi->quorum_threshold_stack, quorum_threshold);
    }
    break;
  default :
    break;
  }
}
#line 2027 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 8: /* query_element ::= BRACEL expression BRACER */
      case 9: /* query_element ::= EVAL primary_expression */ yytestcase(yyruleno==9);
#line 166 "../../groonga/lib/grn_ecmascript.lemon"
{
  efsi->flags = efsi->default_flags;
}
#line 2035 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 10: /* expression ::= expression COMMA assignment_expression */
#line 174 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_COMMA, 2);
}
#line 2042 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 11: /* assignment_expression ::= lefthand_side_expression ASSIGN assignment_expression */
#line 179 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_ASSIGN, 2);
}
#line 2049 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 12: /* assignment_expression ::= lefthand_side_expression STAR_ASSIGN assignment_expression */
#line 182 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_STAR_ASSIGN, 2);
}
#line 2056 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 13: /* assignment_expression ::= lefthand_side_expression SLASH_ASSIGN assignment_expression */
#line 185 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SLASH_ASSIGN, 2);
}
#line 2063 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 14: /* assignment_expression ::= lefthand_side_expression MOD_ASSIGN assignment_expression */
#line 188 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_MOD_ASSIGN, 2);
}
#line 2070 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 15: /* assignment_expression ::= lefthand_side_expression PLUS_ASSIGN assignment_expression */
#line 191 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_PLUS_ASSIGN, 2);
}
#line 2077 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 16: /* assignment_expression ::= lefthand_side_expression MINUS_ASSIGN assignment_expression */
#line 194 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_MINUS_ASSIGN, 2);
}
#line 2084 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 17: /* assignment_expression ::= lefthand_side_expression SHIFTL_ASSIGN assignment_expression */
#line 197 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SHIFTL_ASSIGN, 2);
}
#line 2091 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 18: /* assignment_expression ::= lefthand_side_expression SHIFTR_ASSIGN assignment_expression */
#line 200 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SHIFTR_ASSIGN, 2);
}
#line 2098 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 19: /* assignment_expression ::= lefthand_side_expression SHIFTRR_ASSIGN assignment_expression */
#line 203 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SHIFTRR_ASSIGN, 2);
}
#line 2105 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 20: /* assignment_expression ::= lefthand_side_expression AND_ASSIGN assignment_expression */
#line 206 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_AND_ASSIGN, 2);
}
#line 2112 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 21: /* assignment_expression ::= lefthand_side_expression XOR_ASSIGN assignment_expression */
#line 209 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_XOR_ASSIGN, 2);
}
#line 2119 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 22: /* assignment_expression ::= lefthand_side_expression OR_ASSIGN assignment_expression */
#line 212 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_OR_ASSIGN, 2);
}
#line 2126 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 23: /* conditional_expression ::= logical_or_expression QUESTION assignment_expression COLON assignment_expression */
#line 217 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr *e = (grn_expr *)efsi->e;
  e->codes[yymsp[-3].minor.yy0].nargs = yymsp[-1].minor.yy0 - yymsp[-3].minor.yy0;
  e->codes[yymsp[-1].minor.yy0].nargs = e->codes_curr - yymsp[-1].minor.yy0 - 1;
}
#line 2135 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 27: /* bitwise_or_expression ::= bitwise_or_expression BITWISE_OR bitwise_xor_expression */
#line 237 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_BITWISE_OR, 2);
}
#line 2142 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 28: /* bitwise_xor_expression ::= bitwise_xor_expression BITWISE_XOR bitwise_and_expression */
#line 242 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_BITWISE_XOR, 2);
}
#line 2149 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 29: /* bitwise_and_expression ::= bitwise_and_expression BITWISE_AND equality_expression */
#line 247 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_BITWISE_AND, 2);
}
#line 2156 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 30: /* equality_expression ::= equality_expression EQUAL relational_expression */
#line 252 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_EQUAL, 2);
}
#line 2163 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 31: /* equality_expression ::= equality_expression NOT_EQUAL relational_expression */
#line 255 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_NOT_EQUAL, 2);
}
#line 2170 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 32: /* relational_expression ::= relational_expression LESS shift_expression */
#line 260 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_LESS, 2);
}
#line 2177 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 33: /* relational_expression ::= relational_expression GREATER shift_expression */
#line 263 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_GREATER, 2);
}
#line 2184 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 34: /* relational_expression ::= relational_expression LESS_EQUAL shift_expression */
#line 266 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_LESS_EQUAL, 2);
}
#line 2191 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 35: /* relational_expression ::= relational_expression GREATER_EQUAL shift_expression */
#line 269 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_GREATER_EQUAL, 2);
}
#line 2198 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 36: /* relational_expression ::= relational_expression IN shift_expression */
#line 272 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_IN, 2);
}
#line 2205 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 37: /* relational_expression ::= relational_expression MATCH shift_expression */
      case 92: /* adjust_match_expression ::= IDENTIFIER MATCH STRING */ yytestcase(yyruleno==92);
#line 275 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_MATCH, 2);
}
#line 2213 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 38: /* relational_expression ::= relational_expression NEAR shift_expression */
#line 278 "../../groonga/lib/grn_ecmascript.lemon"
{
  {
    int max_interval;
    GRN_INT32_POP(&efsi->max_interval_stack, max_interval);
    grn_expr_append_const_int(efsi->ctx, efsi->e, max_interval,
                              GRN_OP_PUSH, 1);
  }
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_NEAR, 3);
}
#line 2226 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 39: /* relational_expression ::= relational_expression NEAR2 shift_expression */
#line 287 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_NEAR2, 2);
}
#line 2233 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 40: /* relational_expression ::= relational_expression NEAR_PHRASE shift_expression */
#line 290 "../../groonga/lib/grn_ecmascript.lemon"
{
  {
    int max_interval;
    GRN_INT32_POP(&efsi->max_interval_stack, max_interval);
    grn_expr_append_const_int(efsi->ctx, efsi->e, max_interval,
                              GRN_OP_PUSH, 1);
    int additional_last_interval;
    GRN_INT32_POP(&efsi->additional_last_interval_stack,
                  additional_last_interval);
    grn_expr_append_const_int(efsi->ctx, efsi->e, additional_last_interval,
                              GRN_OP_PUSH, 1);
  }
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_NEAR_PHRASE, 4);
}
#line 2251 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 41: /* relational_expression ::= relational_expression ORDERED_NEAR_PHRASE shift_expression */
#line 304 "../../groonga/lib/grn_ecmascript.lemon"
{
  {
    int max_interval;
    GRN_INT32_POP(&efsi->max_interval_stack, max_interval);
    grn_expr_append_const_int(efsi->ctx, efsi->e, max_interval,
                              GRN_OP_PUSH, 1);
    int additional_last_interval;
    GRN_INT32_POP(&efsi->additional_last_interval_stack,
                  additional_last_interval);
    grn_expr_append_const_int(efsi->ctx, efsi->e, additional_last_interval,
                              GRN_OP_PUSH, 1);
  }
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_ORDERED_NEAR_PHRASE, 4);
}
#line 2269 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 42: /* relational_expression ::= relational_expression SIMILAR shift_expression */
#line 318 "../../groonga/lib/grn_ecmascript.lemon"
{
  {
    int similarity_threshold;
    GRN_INT32_POP(&efsi->similarity_threshold_stack, similarity_threshold);
    grn_expr_append_const_int(efsi->ctx, efsi->e, similarity_threshold,
                              GRN_OP_PUSH, 1);
  }
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SIMILAR, 3);
}
#line 2282 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 43: /* relational_expression ::= relational_expression TERM_EXTRACT shift_expression */
#line 327 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_TERM_EXTRACT, 2);
}
#line 2289 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 44: /* relational_expression ::= relational_expression QUORUM shift_expression */
#line 330 "../../groonga/lib/grn_ecmascript.lemon"
{
  {
    int quorum_threshold;
    GRN_INT32_POP(&efsi->quorum_threshold_stack, quorum_threshold);
    grn_expr_append_const_int(efsi->ctx, efsi->e, quorum_threshold,
                              GRN_OP_PUSH, 1);
  }
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_QUORUM, 3);
}
#line 2302 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 45: /* relational_expression ::= relational_expression LCP shift_expression */
#line 339 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_LCP, 2);
}
#line 2309 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 46: /* relational_expression ::= relational_expression PREFIX shift_expression */
#line 342 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_PREFIX, 2);
}
#line 2316 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 47: /* relational_expression ::= relational_expression SUFFIX shift_expression */
#line 345 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SUFFIX, 2);
}
#line 2323 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 48: /* relational_expression ::= relational_expression REGEXP shift_expression */
#line 348 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_REGEXP, 2);
}
#line 2330 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 49: /* shift_expression ::= shift_expression SHIFTL additive_expression */
#line 353 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SHIFTL, 2);
}
#line 2337 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 50: /* shift_expression ::= shift_expression SHIFTR additive_expression */
#line 356 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SHIFTR, 2);
}
#line 2344 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 51: /* shift_expression ::= shift_expression SHIFTRR additive_expression */
#line 359 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SHIFTRR, 2);
}
#line 2351 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 52: /* additive_expression ::= additive_expression PLUS multiplicative_expression */
      case 90: /* adjuster ::= adjuster PLUS adjust_expression */ yytestcase(yyruleno==90);
#line 364 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_PLUS, 2);
}
#line 2359 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 53: /* additive_expression ::= additive_expression MINUS multiplicative_expression */
#line 367 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_MINUS, 2);
}
#line 2366 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 54: /* multiplicative_expression ::= multiplicative_expression STAR unary_expression */
      case 91: /* adjust_expression ::= adjust_match_expression STAR DECIMAL */ yytestcase(yyruleno==91);
#line 372 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_STAR, 2);
}
#line 2374 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 55: /* multiplicative_expression ::= multiplicative_expression SLASH unary_expression */
#line 375 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_SLASH, 2);
}
#line 2381 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 56: /* multiplicative_expression ::= multiplicative_expression MOD unary_expression */
#line 378 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_MOD, 2);
}
#line 2388 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 57: /* unary_expression ::= DELETE unary_expression */
#line 383 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_DELETE, 1);
}
#line 2395 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 58: /* unary_expression ::= INCR unary_expression */
#line 386 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_expr *e = (grn_expr *)(efsi->e);
  grn_expr_dfi *dfi_;
  unsigned int const_p;

  dfi_ = grn_expr_dfi_pop(e);
  const_p = CONSTP(dfi_->code->value);
  grn_expr_dfi_put(ctx, e, dfi_->type, dfi_->domain, dfi_->code);
  if (const_p) {
    ERR(GRN_SYNTAX_ERROR,
        "constant can't be incremented: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  } else {
    grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_INCR, 1);
  }
}
#line 2416 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 59: /* unary_expression ::= DECR unary_expression */
#line 403 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_expr *e = (grn_expr *)(efsi->e);
  grn_expr_dfi *dfi_;
  unsigned int const_p;

  dfi_ = grn_expr_dfi_pop(e);
  const_p = CONSTP(dfi_->code->value);
  grn_expr_dfi_put(ctx, e, dfi_->type, dfi_->domain, dfi_->code);
  if (const_p) {
    ERR(GRN_SYNTAX_ERROR,
        "constant can't be decremented: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  } else {
    grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_DECR, 1);
  }
}
#line 2437 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 60: /* unary_expression ::= PLUS unary_expression */
#line 420 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_PLUS, 1);
}
#line 2444 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 61: /* unary_expression ::= MINUS unary_expression */
#line 423 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_MINUS, 1);
}
#line 2451 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 62: /* unary_expression ::= NOT unary_expression */
#line 426 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_NOT, 1);
}
#line 2458 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 63: /* unary_expression ::= BITWISE_NOT unary_expression */
#line 429 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_BITWISE_NOT, 1);
}
#line 2465 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 64: /* unary_expression ::= ADJUST unary_expression */
#line 432 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_ADJUST, 1);
}
#line 2472 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 65: /* unary_expression ::= EXACT unary_expression */
#line 435 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_EXACT, 1);
}
#line 2479 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 66: /* unary_expression ::= PARTIAL unary_expression */
#line 438 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_PARTIAL, 1);
}
#line 2486 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 67: /* unary_expression ::= UNSPLIT unary_expression */
#line 441 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_UNSPLIT, 1);
}
#line 2493 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 68: /* postfix_expression ::= lefthand_side_expression INCR */
#line 446 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_expr *e = (grn_expr *)(efsi->e);
  grn_expr_dfi *dfi_;
  unsigned int const_p;

  dfi_ = grn_expr_dfi_pop(e);
  const_p = CONSTP(dfi_->code->value);
  grn_expr_dfi_put(ctx, e, dfi_->type, dfi_->domain, dfi_->code);
  if (const_p) {
    ERR(GRN_SYNTAX_ERROR,
        "constant can't be incremented: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  } else {
    grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_INCR_POST, 1);
  }
}
#line 2514 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 69: /* postfix_expression ::= lefthand_side_expression DECR */
#line 463 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_expr *e = (grn_expr *)(efsi->e);
  grn_expr_dfi *dfi_;
  unsigned int const_p;

  dfi_ = grn_expr_dfi_pop(e);
  const_p = CONSTP(dfi_->code->value);
  grn_expr_dfi_put(ctx, e, dfi_->type, dfi_->domain, dfi_->code);
  if (const_p) {
    ERR(GRN_SYNTAX_ERROR,
        "constant can't be decremented: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  } else {
    grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_DECR_POST, 1);
  }
}
#line 2535 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 70: /* call_expression ::= member_expression arguments */
#line 484 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_CALL, yymsp[0].minor.yy0);
}
#line 2542 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 71: /* array_literal ::= BRACKETL element_list BRACKETR */
#line 501 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  if (efsi->array_literal) {
    grn_expr_take_obj(ctx, efsi->e, efsi->array_literal);
    grn_expr_append_obj(ctx, efsi->e, efsi->array_literal,
                        GRN_OP_PUSH, 1);
    efsi->array_literal = NULL;
  }
}
#line 2555 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 72: /* element_list ::= */
#line 511 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;

  efsi->array_literal = grn_obj_open(ctx, GRN_VECTOR, 0, GRN_ID_NIL);
  if (!efsi->array_literal) {
    ERR(GRN_NO_MEMORY_AVAILABLE,
        "couldn't create vector for parsing array literal: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  }
}
#line 2569 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 73: /* element_list ::= assignment_expression */
      case 74: /* element_list ::= element_list COMMA assignment_expression */ yytestcase(yyruleno==74);
#line 522 "../../groonga/lib/grn_ecmascript.lemon"
{
  array_literal_add_element(efsi);
}
#line 2577 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 75: /* object_literal ::= BRACEL property_name_and_value_list BRACER */
#line 530 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_expr_take_obj(ctx, efsi->e, (grn_obj *)(efsi->object_literal));
  grn_expr_append_obj(ctx, efsi->e, (grn_obj *)(efsi->object_literal),
                      GRN_OP_PUSH, 1);
  efsi->object_literal = NULL;
}
#line 2588 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 76: /* property_name_and_value_list ::= */
#line 538 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;

  efsi->object_literal =
    grn_hash_create(ctx, NULL, GRN_TABLE_MAX_KEY_SIZE, sizeof(grn_obj),
                    GRN_OBJ_KEY_VAR_SIZE|GRN_OBJ_TEMPORARY|GRN_HASH_TINY);
  if (!efsi->object_literal) {
    ERR(GRN_NO_MEMORY_AVAILABLE,
        "couldn't create hash table for parsing object literal: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  } else {
    DB_OBJ(efsi->object_literal)->header.domain = GRN_DB_SHORT_TEXT;
  }
}
#line 2606 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 77: /* property_name_and_value ::= property_name COLON assignment_expression */
#line 555 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_expr *e = (grn_expr *)(efsi->e);
  grn_obj *property = e->codes[e->codes_curr - 3].value;
  grn_obj *value = e->codes[e->codes_curr - 1].value;

  if (!efsi->object_literal) {
     efsi->object_literal =
       grn_hash_create(ctx, NULL, GRN_TABLE_MAX_KEY_SIZE, sizeof(grn_obj),
                       GRN_OBJ_KEY_VAR_SIZE|GRN_OBJ_TEMPORARY|GRN_HASH_TINY);
     if (efsi->object_literal) {
       DB_OBJ(efsi->object_literal)->header.domain = GRN_DB_SHORT_TEXT;
     }
  }

  if (!efsi->object_literal) {
    ERR(GRN_NO_MEMORY_AVAILABLE,
        "couldn't create hash table for parsing object literal: <%.*s>",
        (int)(efsi->str_end - efsi->str), efsi->str);
  } else {
    grn_obj *buf;
    int added;
    if (grn_hash_add(ctx, (grn_hash *)efsi->object_literal,
                     GRN_TEXT_VALUE(property), GRN_TEXT_LEN(property),
                     (void **)&buf, &added)) {
      if (added) {
        switch (value->header.type) {
        case GRN_TABLE_HASH_KEY :
        case GRN_COLUMN_FIX_SIZE :
        case GRN_COLUMN_VAR_SIZE :
        case GRN_COLUMN_INDEX :
          GRN_OBJ_INIT(buf, GRN_PTR, 0, GRN_ID_NIL);
          GRN_PTR_SET(ctx, buf, value);
          break;
        case GRN_VECTOR :
          GRN_OBJ_INIT(buf, value->header.type, 0, value->header.domain);
          grn_vector_copy(ctx, value, buf);
          break;
        default :
          GRN_OBJ_INIT(buf, value->header.type, 0, value->header.domain);
          GRN_TEXT_PUT(ctx, buf, GRN_TEXT_VALUE(value), GRN_TEXT_LEN(value));
          break;
        }
        grn_expr_dfi_pop(e);
        e->codes_curr -= 3;
      } else {
        ERR(GRN_INVALID_ARGUMENT,
            "duplicated property name: <%.*s>",
            (int)GRN_TEXT_LEN(property),
            GRN_TEXT_VALUE(property));
      }
    } else {
      ERR(GRN_NO_MEMORY_AVAILABLE,
          "failed to add a property to object literal: <%.*s>",
          (int)GRN_TEXT_LEN(property),
          GRN_TEXT_VALUE(property));
    }
  }
}
#line 2669 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 78: /* member_expression_part ::= BRACKETL expression BRACKETR */
#line 617 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_GET_MEMBER, 2);
}
#line 2676 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 79: /* arguments ::= PARENL argument_list PARENR */
#line 622 "../../groonga/lib/grn_ecmascript.lemon"
{ yymsp[-2].minor.yy0 = yymsp[-1].minor.yy0; }
#line 2681 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 80: /* argument_list ::= */
#line 623 "../../groonga/lib/grn_ecmascript.lemon"
{ yymsp[1].minor.yy0 = 0; }
#line 2686 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 81: /* argument_list ::= assignment_expression */
#line 624 "../../groonga/lib/grn_ecmascript.lemon"
{ yymsp[0].minor.yy0 = 1; }
#line 2691 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 82: /* argument_list ::= argument_list COMMA assignment_expression */
#line 625 "../../groonga/lib/grn_ecmascript.lemon"
{ yylhsminor.yy0 = yymsp[-2].minor.yy0 + 1; }
#line 2696 "../../groonga/lib/grn_ecmascript.c"
  yymsp[-2].minor.yy0 = yylhsminor.yy0;
        break;
      case 83: /* output_columns ::= */
      case 93: /* sort_keys ::= */ yytestcase(yyruleno==93);
#line 627 "../../groonga/lib/grn_ecmascript.lemon"
{
  yymsp[1].minor.yy0 = 0;
}
#line 2705 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 84: /* output_columns ::= output_column */
      case 94: /* sort_keys ::= sort_key */ yytestcase(yyruleno==94);
#line 630 "../../groonga/lib/grn_ecmascript.lemon"
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
}
#line 2713 "../../groonga/lib/grn_ecmascript.c"
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 85: /* output_columns ::= output_columns COMMA */
#line 635 "../../groonga/lib/grn_ecmascript.lemon"
{
  yylhsminor.yy0 = yymsp[-1].minor.yy0;
}
#line 2721 "../../groonga/lib/grn_ecmascript.c"
  yymsp[-1].minor.yy0 = yylhsminor.yy0;
        break;
      case 86: /* output_columns ::= output_columns COMMA output_column */
      case 95: /* sort_keys ::= sort_keys COMMA sort_key */ yytestcase(yyruleno==95);
#line 640 "../../groonga/lib/grn_ecmascript.lemon"
{
  if (yymsp[-2].minor.yy0 == 0) {
    yylhsminor.yy0 = yymsp[0].minor.yy0;
  } else if (yymsp[0].minor.yy0 == 0) {
    yylhsminor.yy0 = yymsp[-2].minor.yy0;
  } else {
    if (yymsp[0].minor.yy0 == 1) {
      grn_expr_append_op(efsi->ctx, efsi->e, GRN_OP_COMMA, 2);
    }
    yylhsminor.yy0 = 1;
  }
}
#line 2739 "../../groonga/lib/grn_ecmascript.c"
  yymsp[-2].minor.yy0 = yylhsminor.yy0;
        break;
      case 87: /* output_column ::= STAR */
#line 653 "../../groonga/lib/grn_ecmascript.lemon"
{
  grn_ctx *ctx = efsi->ctx;
  grn_obj *expr = efsi->e;
  grn_obj *variable = grn_expr_get_var_by_offset(ctx, expr, 0);
  if (variable) {
    grn_id table_id = GRN_OBJ_GET_DOMAIN(variable);
    grn_obj *table = grn_ctx_at(ctx, table_id);
    grn_obj columns_buffer;
    int n_columns;
    grn_obj **columns;

    GRN_PTR_INIT(&columns_buffer, GRN_OBJ_VECTOR, GRN_ID_NIL);
    grn_obj_columns(ctx, table, "*", strlen("*"), &columns_buffer);
    n_columns = GRN_BULK_VSIZE(&columns_buffer) / sizeof(grn_obj *);
    columns = (grn_obj **)GRN_BULK_HEAD(&columns_buffer);

    if (n_columns == 0) {
      /* do nothing */
    } else if (n_columns == 1) {
      grn_obj *column = columns[0];
      grn_expr_append_const(ctx, expr, column, GRN_OP_GET_VALUE, 1);
      grn_expr_take_obj(ctx, expr, column);
    } else {
      grn_expr *e = (grn_expr *)expr;
      grn_bool have_column;
      int i;

      have_column = (e->codes_curr > 0);
      for (i = 0; i < n_columns; i++) {
        grn_obj *column = columns[i];
        grn_expr_append_const(ctx, expr, column, GRN_OP_GET_VALUE, 1);
        if (have_column || i > 0) {
          grn_expr_append_op(ctx, expr, GRN_OP_COMMA, 2);
        }
        grn_expr_take_obj(ctx, expr, column);
      }
    }

    if (grn_enable_reference_count) {
      grn_obj_unlink(ctx, table);
    }
    GRN_OBJ_FIN(ctx, &columns_buffer);

    yymsp[0].minor.yy0 = n_columns;
  } else {
    /* TODO: report error */
    yymsp[0].minor.yy0 = 0;
  }
}
#line 2793 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 88: /* output_column ::= NONEXISTENT_COLUMN */
      case 96: /* sort_key ::= NONEXISTENT_COLUMN */ yytestcase(yyruleno==96);
#line 702 "../../groonga/lib/grn_ecmascript.lemon"
{
  yymsp[0].minor.yy0 = 0;
}
#line 2801 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 89: /* output_column ::= assignment_expression */
      case 98: /* sort_key ::= assignment_expression */ yytestcase(yyruleno==98);
#line 705 "../../groonga/lib/grn_ecmascript.lemon"
{
  yymsp[0].minor.yy0 = 1;
}
#line 2809 "../../groonga/lib/grn_ecmascript.c"
        break;
      case 97: /* sort_key ::= MINUS NONEXISTENT_COLUMN */
#line 748 "../../groonga/lib/grn_ecmascript.lemon"
{
  yymsp[-1].minor.yy0 = 0;
}
#line 2816 "../../groonga/lib/grn_ecmascript.c"
        break;
      default:
      /* (99) input ::= query */ yytestcase(yyruleno==99);
      /* (100) input ::= expression */ yytestcase(yyruleno==100);
      /* (101) input ::= START_OUTPUT_COLUMNS output_columns */ yytestcase(yyruleno==101);
      /* (102) input ::= START_ADJUSTER adjuster */ yytestcase(yyruleno==102);
      /* (103) input ::= START_SORT_KEYS sort_keys */ yytestcase(yyruleno==103);
      /* (104) query ::= query_element (OPTIMIZED OUT) */ assert(yyruleno!=104);
      /* (105) query_element ::= QSTRING */ yytestcase(yyruleno==105);
      /* (106) query_element ::= PARENL query PARENR */ yytestcase(yyruleno==106);
      /* (107) expression ::= assignment_expression (OPTIMIZED OUT) */ assert(yyruleno!=107);
      /* (108) assignment_expression ::= conditional_expression (OPTIMIZED OUT) */ assert(yyruleno!=108);
      /* (109) conditional_expression ::= logical_or_expression */ yytestcase(yyruleno==109);
      /* (110) logical_or_expression ::= logical_and_expression */ yytestcase(yyruleno==110);
      /* (111) logical_and_expression ::= bitwise_or_expression */ yytestcase(yyruleno==111);
      /* (112) bitwise_or_expression ::= bitwise_xor_expression */ yytestcase(yyruleno==112);
      /* (113) bitwise_xor_expression ::= bitwise_and_expression */ yytestcase(yyruleno==113);
      /* (114) bitwise_and_expression ::= equality_expression */ yytestcase(yyruleno==114);
      /* (115) equality_expression ::= relational_expression */ yytestcase(yyruleno==115);
      /* (116) relational_expression ::= shift_expression */ yytestcase(yyruleno==116);
      /* (117) shift_expression ::= additive_expression */ yytestcase(yyruleno==117);
      /* (118) additive_expression ::= multiplicative_expression */ yytestcase(yyruleno==118);
      /* (119) multiplicative_expression ::= unary_expression (OPTIMIZED OUT) */ assert(yyruleno!=119);
      /* (120) unary_expression ::= postfix_expression (OPTIMIZED OUT) */ assert(yyruleno!=120);
      /* (121) postfix_expression ::= lefthand_side_expression */ yytestcase(yyruleno==121);
      /* (122) lefthand_side_expression ::= call_expression (OPTIMIZED OUT) */ assert(yyruleno!=122);
      /* (123) lefthand_side_expression ::= member_expression */ yytestcase(yyruleno==123);
      /* (124) member_expression ::= primary_expression (OPTIMIZED OUT) */ assert(yyruleno!=124);
      /* (125) member_expression ::= member_expression member_expression_part */ yytestcase(yyruleno==125);
      /* (126) primary_expression ::= object_literal (OPTIMIZED OUT) */ assert(yyruleno!=126);
      /* (127) primary_expression ::= PARENL expression PARENR */ yytestcase(yyruleno==127);
      /* (128) primary_expression ::= IDENTIFIER */ yytestcase(yyruleno==128);
      /* (129) primary_expression ::= array_literal (OPTIMIZED OUT) */ assert(yyruleno!=129);
      /* (130) primary_expression ::= DECIMAL */ yytestcase(yyruleno==130);
      /* (131) primary_expression ::= HEX_INTEGER */ yytestcase(yyruleno==131);
      /* (132) primary_expression ::= STRING */ yytestcase(yyruleno==132);
      /* (133) primary_expression ::= BOOLEAN */ yytestcase(yyruleno==133);
      /* (134) primary_expression ::= NULL */ yytestcase(yyruleno==134);
      /* (135) property_name_and_value_list ::= property_name_and_value (OPTIMIZED OUT) */ assert(yyruleno!=135);
      /* (136) property_name_and_value_list ::= property_name_and_value_list COMMA property_name_and_value */ yytestcase(yyruleno==136);
      /* (137) property_name ::= STRING */ yytestcase(yyruleno==137);
      /* (138) member_expression_part ::= DOT IDENTIFIER */ yytestcase(yyruleno==138);
      /* (139) adjuster ::= */ yytestcase(yyruleno==139);
      /* (140) adjuster ::= adjust_expression (OPTIMIZED OUT) */ assert(yyruleno!=140);
      /* (141) adjust_expression ::= adjust_match_expression */ yytestcase(yyruleno==141);
        break;
/********** End reduce actions ************************************************/
  };
  assert( yyruleno<sizeof(yyRuleInfoLhs)/sizeof(yyRuleInfoLhs[0]) );
  yygoto = yyRuleInfoLhs[yyruleno];
  yysize = yyRuleInfoNRhs[yyruleno];
  yyact = yy_find_reduce_action(yymsp[yysize].stateno,(YYCODETYPE)yygoto);

  /* There are no SHIFTREDUCE actions on nonterminals because the table
  ** generator has simplified them to pure REDUCE actions. */
  assert( !(yyact>YY_MAX_SHIFT && yyact<=YY_MAX_SHIFTREDUCE) );

  /* It is not possible for a REDUCE to be followed by an error */
  assert( yyact!=YY_ERROR_ACTION );

  yymsp += yysize+1;
  yypParser->yytos = yymsp;
  yymsp->stateno = (YYACTIONTYPE)yyact;
  yymsp->major = (YYCODETYPE)yygoto;
  yyTraceShift(yypParser, yyact, "... then shift");
  return yyact;
}

/*
** The following code executes when the parse fails
*/
#ifndef YYNOERRORRECOVERY
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  grn_expr_parserARG_FETCH
  grn_expr_parserCTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
/************ Begin %parse_failure code ***************************************/
/************ End %parse_failure code *****************************************/
  grn_expr_parserARG_STORE /* Suppress warning about unused %extra_argument variable */
  grn_expr_parserCTX_STORE
}
#endif /* YYNOERRORRECOVERY */

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  grn_expr_parserTOKENTYPE yyminor         /* The minor type of the error token */
){
  grn_expr_parserARG_FETCH
  grn_expr_parserCTX_FETCH
#define TOKEN yyminor
/************ Begin %syntax_error code ****************************************/
#line 62 "../../groonga/lib/grn_ecmascript.lemon"

  {
    grn_ctx *ctx = efsi->ctx;
    grn_obj message;
    GRN_TEXT_INIT(&message, 0);
    GRN_TEXT_PUT(ctx, &message, efsi->str, efsi->cur - efsi->str);
    GRN_TEXT_PUTC(ctx, &message, '|');
    if (efsi->cur < efsi->str_end) {
      GRN_TEXT_PUTC(ctx, &message, efsi->cur[0]);
      GRN_TEXT_PUTC(ctx, &message, '|');
      GRN_TEXT_PUT(ctx, &message,
                   efsi->cur + 1, efsi->str_end - (efsi->cur + 1));
    } else {
      GRN_TEXT_PUTC(ctx, &message, '|');
    }
    if (ctx->rc == GRN_SUCCESS) {
      ERR(GRN_SYNTAX_ERROR, "Syntax error: <%.*s>",
          (int)GRN_TEXT_LEN(&message), GRN_TEXT_VALUE(&message));
    } else {
      char errbuf[GRN_CTX_MSGSIZE];
      grn_strcpy(errbuf, GRN_CTX_MSGSIZE, ctx->errbuf);
      ERR(ctx->rc, "Syntax error: <%.*s>: %s",
          (int)GRN_TEXT_LEN(&message), GRN_TEXT_VALUE(&message),
          errbuf);
    }
    GRN_OBJ_FIN(ctx, &message);
  }
#line 2949 "../../groonga/lib/grn_ecmascript.c"
/************ End %syntax_error code ******************************************/
  grn_expr_parserARG_STORE /* Suppress warning about unused %extra_argument variable */
  grn_expr_parserCTX_STORE
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  grn_expr_parserARG_FETCH
  grn_expr_parserCTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  assert( yypParser->yytos==yypParser->yystack );
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
/*********** Begin %parse_accept code *****************************************/
/*********** End %parse_accept code *******************************************/
  grn_expr_parserARG_STORE /* Suppress warning about unused %extra_argument variable */
  grn_expr_parserCTX_STORE
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "grn_expr_parserAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void grn_expr_parser(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  grn_expr_parserTOKENTYPE yyminor       /* The value for the token */
  grn_expr_parserARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  YYACTIONTYPE yyact;   /* The parser action. */
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  int yyendofinput;     /* True if we are at the end of input */
#endif
#ifdef YYERRORSYMBOL
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
#endif
  yyParser *yypParser = (yyParser*)yyp;  /* The parser */
  grn_expr_parserCTX_FETCH
  grn_expr_parserARG_STORE

  assert( yypParser->yytos!=0 );
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  yyendofinput = (yymajor==0);
#endif

  yyact = yypParser->yytos->stateno;
#ifndef NDEBUG
  if( yyTraceFILE ){
    if( yyact < YY_MIN_REDUCE ){
      fprintf(yyTraceFILE,"%sInput '%s' in state %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact);
    }else{
      fprintf(yyTraceFILE,"%sInput '%s' with pending reduce %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact-YY_MIN_REDUCE);
    }
  }
#endif

  do{
    assert( yyact==yypParser->yytos->stateno );
    yyact = yy_find_shift_action((YYCODETYPE)yymajor,yyact);
    if( yyact >= YY_MIN_REDUCE ){
      yyact = yy_reduce(yypParser,yyact-YY_MIN_REDUCE,yymajor,
                        yyminor grn_expr_parserCTX_PARAM);
    }else if( yyact <= YY_MAX_SHIFTREDUCE ){
      yy_shift(yypParser,yyact,(YYCODETYPE)yymajor,yyminor);
#ifndef YYNOERRORRECOVERY
      yypParser->yyerrcnt--;
#endif
      break;
    }else if( yyact==YY_ACCEPT_ACTION ){
      yypParser->yytos--;
      yy_accept(yypParser);
      return;
    }else{
      assert( yyact == YY_ERROR_ACTION );
      yyminorunion.yy0 = yyminor;
#ifdef YYERRORSYMBOL
      int yymx;
#endif
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminor);
      }
      yymx = yypParser->yytos->major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yypParser, (YYCODETYPE)yymajor, &yyminorunion);
        yymajor = YYNOCODE;
      }else{
        while( yypParser->yytos >= yypParser->yystack
            && (yyact = yy_find_reduce_action(
                        yypParser->yytos->stateno,
                        YYERRORSYMBOL)) > YY_MAX_SHIFTREDUCE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yytos < yypParser->yystack || yymajor==0 ){
          yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
          yypParser->yyerrcnt = -1;
#endif
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          yy_shift(yypParser,yyact,YYERRORSYMBOL,yyminor);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
      if( yymajor==YYNOCODE ) break;
      yyact = yypParser->yytos->stateno;
#elif defined(YYNOERRORRECOVERY)
      /* If the YYNOERRORRECOVERY macro is defined, then do not attempt to
      ** do any kind of error recovery.  Instead, simply invoke the syntax
      ** error routine and continue going as if nothing had happened.
      **
      ** Applications can set this macro (for example inside %include) if
      ** they intend to abandon the parse upon the first syntax error seen.
      */
      yy_syntax_error(yypParser,yymajor, yyminor);
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      break;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor, yyminor);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
        yypParser->yyerrcnt = -1;
#endif
      }
      break;
#endif
    }
  }while( yypParser->yytos>yypParser->yystack );
#ifndef NDEBUG
  if( yyTraceFILE ){
    yyStackEntry *i;
    char cDiv = '[';
    fprintf(yyTraceFILE,"%sReturn. Stack=",yyTracePrompt);
    for(i=&yypParser->yystack[1]; i<=yypParser->yytos; i++){
      fprintf(yyTraceFILE,"%c%s", cDiv, yyTokenName[i->major]);
      cDiv = ' ';
    }
    fprintf(yyTraceFILE,"]\n");
  }
#endif
  return;
}

/*
** Return the fallback token corresponding to canonical token iToken, or
** 0 if iToken has no fallback.
*/
int grn_expr_parserFallback(int iToken){
#ifdef YYFALLBACK
  assert( iToken<(int)(sizeof(yyFallback)/sizeof(yyFallback[0])) );
  return yyFallback[iToken];
#else
  (void)iToken;
  return 0;
#endif
}
